package fem;
import figure.DefaultMatrix;
import figure.Matrix;

//--------------------------------------------------------------------//
/**
 * ޗNX
 */
public class Material implements Cloneable,LabeledData{

/** ޗԍ */
  public int label;

/** O (ceW) */
  public double youngsModulus;

/** eW */
  public double shareModulus;

/** |A\ */
  public double poissonsRatio;

/** x */
  public double density;

/** M` */
  public double heatConductivity;

/** M */
  public double specificHeat;

/** ̐ϔM */
  public double cv;

/**  - c}gbNX */
  private Matrix matrix;

/**
 * ޗIuWFNg\z
 * @param label ޗԍ
 */
  public Material(int label){
    this(label,1.0,0.3,1.0,1.0,1.0);
  }

/**
 * ޗIuWFNg\z
 * @param label ޗԍ
 * @param youngsModulus O
 * @param poissonsRatio |A\
 * @param density x
 * @param heatConductivity M`
 * @param specificHeat M
 */
  public Material(int label,double youngsModulus,double poissonsRatio,
      	      	  double density,double heatConductivity,
      	      	  double specificHeat){
    this.label=label;
    this.youngsModulus=youngsModulus;
    this.poissonsRatio=poissonsRatio;
    this.density=density;
    this.heatConductivity=heatConductivity;
    this.specificHeat=specificHeat;
    shareModulus=0.5*youngsModulus/(1.0+poissonsRatio);
    cv=density*specificHeat;
  }

//--------------------------------------------------------------------//
/**
 * ޗԍԂ
 * @return ޗԍ
 */
  public int label(){
    return label;
  }

//--------------------------------------------------------------------//
/**
 * ޗԍݒ肷
 * @param label ޗԍ
 */
  public void setLabel(int label){
    this.label=label;
  }

//--------------------------------------------------------------------//
/**
 *  - c}gbNXԂ
 * @return  - c}gbNX
 */
  public Matrix matrix(){
    return matrix;
  }

//--------------------------------------------------------------------//
/**
 * ʉ͖̉ - c}gbNX쐬
 */
  public void matrix2Dstress(){
    matrix=new DefaultMatrix(3);
    double coef=youngsModulus/(1.0-poissonsRatio*poissonsRatio);
    matrix.set(0,0,coef);
    matrix.set(0,1,coef*poissonsRatio);
    matrix.set(1,0,coef*poissonsRatio);
    matrix.set(1,1,coef);
    matrix.set(2,2,shareModulus);
  }

//--------------------------------------------------------------------//
/**
 * ʘc̉ - c}gbNX쐬
 */
  public void matrix2Dstrain(){
    matrix=new DefaultMatrix(3);
    double coef=(1.0+poissonsRatio)*(1.0-2.0*poissonsRatio);
    coef=youngsModulus/coef;
    matrix.set(0,0,coef*(1.0-poissonsRatio));
    matrix.set(0,1,coef*poissonsRatio);
    matrix.set(1,0,coef*poissonsRatio);
    matrix.set(1,1,coef*(1.0-poissonsRatio));
    matrix.set(2,2,shareModulus);
  }

//--------------------------------------------------------------------//
/**
 * Ώ̖̉ - c}gbNX쐬
 */
  public void matrixAxiSymetric(){
    matrix=new DefaultMatrix(4);
    double coef=(1.0+poissonsRatio)*(1.0-2.0*poissonsRatio);
    coef=youngsModulus/coef;
    double s1=coef*(1.0-poissonsRatio);
    double s2=coef*poissonsRatio;
    matrix.set(0,0,s1);
    matrix.set(0,1,s2);
    matrix.set(0,2,s2);
    matrix.set(1,0,s2);
    matrix.set(1,1,s1);
    matrix.set(1,2,s2);
    matrix.set(2,0,s2);
    matrix.set(2,1,s2);
    matrix.set(2,2,s1);
    matrix.set(3,3,shareModulus);
  }

//--------------------------------------------------------------------//
/**
 * ̉ - c}gbNX쐬
 */
  public void matrixTorsion(){
    matrix=new DefaultMatrix(2);
    matrix.set(0,0,shareModulus);
    matrix.set(1,1,shareModulus);
  }

//--------------------------------------------------------------------//
/**
 * 3 ̉ - c}gbNX쐬
 */
  public void matrix3D(){
    matrix=new DefaultMatrix(6);
    double coef=(1.0+poissonsRatio)*(1.0-2.0*poissonsRatio);
    coef=youngsModulus/coef;
    double s1=coef*(1.0-poissonsRatio);
    double s2=coef*poissonsRatio;
    matrix.set(0,0,s1);
    matrix.set(0,1,s2);
    matrix.set(0,2,s2);
    matrix.set(1,0,s2);
    matrix.set(1,1,s1);
    matrix.set(1,2,s2);
    matrix.set(2,0,s2);
    matrix.set(2,1,s2);
    matrix.set(2,2,s1);
    matrix.set(3,3,shareModulus);
    matrix.set(4,4,shareModulus);
    matrix.set(5,5,shareModulus);
  }

//--------------------------------------------------------------------//
/**
 * VFvf̉ - c}gbNX쐬
 */
  public void matrixShell(){
    matrix=new DefaultMatrix(5);
    double coef=youngsModulus/(1.0-poissonsRatio*poissonsRatio);
    double s2=coef*poissonsRatio;
    double kk=5.0/6.0;
    matrix.set(0,0,coef);
    matrix.set(0,1,s2);
    matrix.set(1,0,s2);
    matrix.set(1,1,coef);
    matrix.set(2,2,shareModulus);
    matrix.set(3,3,kk*shareModulus);
    matrix.set(4,4,kk*shareModulus);
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      return super.clone();
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    long ll[]={Double.doubleToLongBits(youngsModulus),
      	       Double.doubleToLongBits(shareModulus),
      	       Double.doubleToLongBits(poissonsRatio),
      	       Double.doubleToLongBits(density),
      	       Double.doubleToLongBits(heatConductivity),
      	       Double.doubleToLongBits(specificHeat)};
    int bit=label;
    for(int i=0;i<ll.length;i++){
      bit=31*bit+(int)(ll[i]^(ll[i]>>>32));
    }
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>Material</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof Material){
      Material m=(Material)obj;
      return ((label==m.label)
      	   && (youngsModulus==m.youngsModulus)
      	   && (poissonsRatio==m.poissonsRatio)
      	   && (density==m.density)
      	   && (heatConductivity==m.heatConductivity)
      	   && (specificHeat==m.specificHeat));
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "Material\t"+label+"\t"+youngsModulus+"\t"+poissonsRatio+"\t"
      	  +shareModulus+"\t"+density+"\t"+heatConductivity+"\t"
      	  +specificHeat;
  }
}
