package fem;
import java.util.ArrayList;
import java.util.Collections;
import figure.Cube3D;

//--------------------------------------------------------------------//
/**
 * bVf
 */
public class MeshModel{

/** x̔rIuWFNg */
  public static final LabelComparator
    LABEL_COMPARATOR=new LabelComparator();

/** ߓ_W̔rIuWFNg */
  public static final NodesComparator
    NODES_COMPARATOR=new NodesComparator();

/** ߓ_i[Xg */
  protected ArrayList<Node> nodes;

/** vfi[Xg */
  protected ArrayList<Element> elements;

/** \ʂi[Xg */
  protected ArrayList<ElementBorder> freefaces;

/** fE\ <code>Cube3D</code> */
  public Cube3D bounds;

/**
 * bVf\z
 */
  public MeshModel(){
    nodes=new ArrayList<Node>();
    elements=new ArrayList<Element>();
    freefaces=new ArrayList<ElementBorder>();
    bounds=new Cube3D();
  }

//--------------------------------------------------------------------//
/**
 * ߓ_Ԃ
 * @return ߓ_
 */
  public int getNodeCount(){
    return nodes.size();
  }

//--------------------------------------------------------------------//
/**
 * ߓ_Ԃ
 * @param index ߓ_̃CfbNX
 * @return w肳ꂽʒu̐ߓ_
 */
  public Node getNode(int index){
    return nodes.get(index);
  }

//--------------------------------------------------------------------//
/**
 * ߓ_ǉ
 * @param node ߓ_
 */
  public void addNode(Node node){
    nodes.add(node);
  }

//--------------------------------------------------------------------//
/**
 * vfԂ
 * @return vf
 */
  public int getElementCount(){
    return elements.size();
  }

//--------------------------------------------------------------------//
/**
 * vfԂ
 * @param index vf̃CfbNX
 * @return w肳ꂽʒu̗vf
 */
  public Element getElement(int index){
    return elements.get(index);
  }

//--------------------------------------------------------------------//
/**
 * vfǉ
 * @param element vf
 */
  public void addElement(Element element){
    elements.add(element);
  }

//--------------------------------------------------------------------//
/**
 * \ʂ̐Ԃ
 * @return \ʂ̐
 */
  public int getFaceCount(){
    return freefaces.size();
  }

//--------------------------------------------------------------------//
/**
 * vf\ʂԂ
 * @param index vf\ʂ̃CfbNX
 * @return w肳ꂽʒu̗vf\
 */
  public ElementBorder getFreeFace(int index){
    return freefaces.get(index);
  }

//--------------------------------------------------------------------//
/**
 * ߓ_Ԃ
 * @param nodes ߓ_W
 * @return ߓ_i[z
 */
  public Node[] nodes(Nodes nodes){
    int nodeCount=nodes.nodeCount();
    Node p[]=new Node[nodeCount];
    for(int j=0;j<nodeCount;j++){
      p[j]=getNode(nodes.node(j));
    }
    return p;
  }

//--------------------------------------------------------------------//
/**
 * bV
 */
  public void clear(){
    nodes.clear();
    elements.clear();
    freefaces.clear();
    bounds=new Cube3D();
  }

//--------------------------------------------------------------------//
/**
 * f
 */
  public void init(){
    nodes.trimToSize();
    elements.trimToSize();
    Collections.sort(nodes,LABEL_COMPARATOR);
    modelBounds();
  }

//--------------------------------------------------------------------//
/**
 * \ʂo
 */
  public void getFreeFaces(){
    int nodeCount=nodes.size();
    int elementCount=elements.size();
    if(elementCount==0) return;
    ArrayList<ElementBorder> border=new ArrayList<ElementBorder>();
    for(int i=0;i<elementCount;i++){
      Element element=getElement(i);
      if(element instanceof ShellElement){
      	freefaces.add(element.border(i,0));
      }
      else{
      	int borderCount=element.borderCount();
      	for(int j=0;j<borderCount;j++){
      	  border.add(element.border(i,j));
      	}
      }
    }
    border.trimToSize();
    int borderCount=border.size();
    if(borderCount>0){
      Collections.sort(border,NODES_COMPARATOR);

      ElementBorder beforeeb=border.get(0);
      boolean addsw=true;
      for(int i=1;i<borderCount;i++){
      	ElementBorder eb=border.get(i);
      	if(beforeeb.equals(eb)){
      	  addsw=false;
      	}
      	else{
      	  if(addsw) freefaces.add(beforeeb);
      	  beforeeb=eb;
      	  addsw=true;
      	}
      }
      if(addsw) freefaces.add(beforeeb);
    }
    freefaces.trimToSize();
  }

//--------------------------------------------------------------------//
/**
 * fEݒ肷
 */
  public void modelBounds(){
    int nodeCount=nodes.size();
    if(nodeCount==0) return;
    Node p=getNode(0);
    double xMax=p.x;
    double xMin=p.x;
    double yMax=p.y;
    double yMin=p.y;
    double zMax=p.z;
    double zMin=p.z;
    for(int i=1;i<nodeCount;i++){
      p=getNode(i);
      xMax=Math.max(p.x,xMax);
      xMin=Math.min(p.x,xMin);
      yMax=Math.max(p.y,yMax);
      yMin=Math.min(p.y,yMin);
      zMax=Math.max(p.z,zMax);
      zMin=Math.min(p.z,zMin);
    }
    bounds.setBounds(xMin,yMin,zMin,xMax-xMin,yMax-yMin,zMax-zMin);
  }

//--------------------------------------------------------------------//
/**
 * fEԂ
 * @return fE\
 */
  public Cube3D getBounds(){
    return bounds;
  }
}
