package fem;
import fem.result.Strain;
import fem.result.Stress;
import figure.Matrix;
import figure.Point3D;
import figure.Vector3D;

//--------------------------------------------------------------------//
/**
 * vfC^[tFCX
 */
public interface SolidElement extends Element{

//--------------------------------------------------------------------//
/**
 * `֐s<br>
 * { <i>N<sub>i</sub></i>
 *   <i>dN<sub>i</sub></i> /<i>d</i>
 *   <i>dN<sub>i</sub></i> /<i>d</i>
 *   <i>dN<sub>i</sub></i> /<i>d</i> }<br>
 * Ԃ
 * @param xsi <i></i> W
 * @param eta <i></i> W
 * @param zeta <i></i> W
 * @return `֐s
 */
  Matrix shapeFunction(double xsi,double eta,double zeta);

/**
 * vfcԂ
 * @param p ߓ_i[z
 * @param d ߓ_ψʂi[z
 * @return vfci[z
 */
  Strain[] strain(Point3D p[],Vector3D d[]);

/**
 * vf͂Ԃ
 * @param strain vfci[z
 * @param material ޗ
 * @return vf͂i[z
 */
  Stress[] stress(Strain strain[],Material material);

/**
 * vf͂Ԃ
 * @param strain vfci[z
 * @param d1  - c}gbNX
 * @return vf͂i[z
 */
  Stress[] stress(Strain strain[],Matrix d1);

/**
 * vf͂Ԃ
 * @param p ߓ_i[z
 * @param d ߓ_ψʂi[z
 * @param material ޗ
 * @return vf͂i[z
 */
  Stress[] stress(Point3D p[],Vector3D d[],Material material);

/**
 * vf͂Ԃ
 * @param p ߓ_i[z
 * @param d ߓ_ψʂi[z
 * @param d1  - c}gbNX
 * @return vf͂i[z
 */
  Stress[] stress(Point3D p[],Vector3D d[],Matrix d1);

/**
 * `֐}gbNX<br>
 * { <i>N<sub>i</sub>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return `֐}gbNX
 */
  Matrix shapeFunctionMatrix(Point3D p[],double coef);

/**
 * gU}gbNX<br>
 * { <i>N<sub>i</sub></i>E<i>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return gU}gbNX
 */
  Matrix gradMatrix(Point3D p[],double coef);
}
