package fem.bc;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import fem.ElementBorder;
import fem.LabelComparator;
import figure.Vector;

//--------------------------------------------------------------------//
/**
 * ENX
 */
public class BoundaryCondition{

/** x̔rIuWFNg */
  protected static final LabelComparator
    LABEL_COMPARATOR=new LabelComparator();

/** Si[郊Xg */
  protected ArrayList<Restraint> restraints;

/** ׏di[郊Xg */
  protected ArrayList<Load> loads;

/** ʈi[郊Xg */
  protected ArrayList<Pressure> pressures;

/** ߓ_xi[郊Xg */
  protected ArrayList<Temperature> temperature;

/** M`BEi[郊Xg */
  protected ArrayList<HeatTransferBound> htcs;

/** ׏d̑傫̍ől */
  protected double loadMax;

/** ʈ̍ől */
  protected double pressMax;

/** ߓ_ */
  public int nodeCount;

/** ߓ_̎Rxi[z */
  protected int dof[];

/** ߓ_|C^i[z **/
  protected int nodeIndex[];

/** Eݒ肵ߓ_̃CfbNXi[z **/
  public int bcList[];

/**
 * EIuWFNg\z
 */
  public BoundaryCondition(){
    restraints=new ArrayList<Restraint>();
    loads=new ArrayList<Load>();
    pressures=new ArrayList<Pressure>();
    temperature=new ArrayList<Temperature>();
    htcs=new ArrayList<HeatTransferBound>();
    loadMax=0.0;
    pressMax=0.0;
  }

//--------------------------------------------------------------------//
/**
 * S_̐Ԃ
 * @return S_̐
 */
  public int restraintCount(){
    return restraints.size();
  }

//--------------------------------------------------------------------//
/**
 * SԂ
 * @param index S̃CfbNX
 * @return w肳ꂽʒu̍S
 */
  public Restraint getRestraint(int index){
    return restraints.get(index);
  }

//--------------------------------------------------------------------//
/**
 * Sǉ
 * @param restraint S
 */
  public void addRestraint(Restraint restraint){
    restraints.add(restraint);
  }

//--------------------------------------------------------------------//
/**
 * ׏d_̐Ԃ
 * @return ׏d_̐
 */
  public int loadCount(){
    return loads.size();
  }

//--------------------------------------------------------------------//
/**
 * ׏dԂ
 * @param index ׏d̃CfbNX
 * @return w肳ꂽʒủ׏d
 */
  public Load getLoad(int index){
    return loads.get(index);
  }

//--------------------------------------------------------------------//
/**
 * ׏d̑傫̍őlԂ
 * @return ׏d̑傫̍ől
 */
  public double loadMax(){
    return loadMax;
  }

//--------------------------------------------------------------------//
/**
 * ׏dǉ
 * @param load ׏d
 */
  public void addLoad(Load load){
    loads.add(load);
    loadMax=Math.max(loadMax,load.magnitude());
  }

//--------------------------------------------------------------------//
/**
 * ʈʂ̐Ԃ
 * @return ʈʂ̐
 */
  public int pressureCount(){
    return pressures.size();
  }

//--------------------------------------------------------------------//
/**
 * ʈԂ
 * @param index ʈ̃CfbNX
 * @return w肳ꂽʒu̖ʈ
 */
  public Pressure getPressure(int index){
    return pressures.get(index);
  }

//--------------------------------------------------------------------//
/**
 * ʈ̍őlԂ
 * @return ʈ̍ől
 */
  public double pressMax(){
    return pressMax;
  }

//--------------------------------------------------------------------//
/**
 * ʈǉ
 * @param pressure ʈ
 */
  public void addPressure(Pressure pressure){
    pressures.add(pressure);
    pressMax=Math.max(pressMax,pressure.press);
  }

//--------------------------------------------------------------------//
/**
 * xŒ̐Ԃ
 * @return xŒ̐
 */
  public int temperatureCount(){
    return temperature.size();
  }

//--------------------------------------------------------------------//
/**
 * xŒԂ
 * @param index xŒ̃CfbNX
 * @return w肳ꂽʒủxŒ
 */
  public Temperature getTemperature(int index){
    return temperature.get(index);
  }

//--------------------------------------------------------------------//
/**
 * xŒǉ
 * @param t xŒ
 */
  public void addTemperature(Temperature t){
    temperature.add(t);
  }

//--------------------------------------------------------------------//
/**
 * M`BE^ʂ̐Ԃ
 * @return M`BE^ʂ̐
 */
  public int htcCount(){
    return htcs.size();
  }

//--------------------------------------------------------------------//
/**
 * M`BEԂ
 * @param index M`BẼCfbNX
 * @return w肳ꂽʒu̔M`BE
 */
  public HeatTransferBound getHTBound(int index){
    return htcs.get(index);
  }

//--------------------------------------------------------------------//
/**
 * M`BEǉ
 * @param htc M`BE
 */
  public void addHTBound(HeatTransferBound htc){
    htcs.add(htc);
  }

//--------------------------------------------------------------------//
/**
 * E
 */
  public void clear(){
    restraints.clear();
    loads.clear();
    pressures.clear();
    temperature.clear();
    htcs.clear();
    loadMax=0.0;
    pressMax=0.0;
  }

//--------------------------------------------------------------------//
/**
 * E
 */
  public void init(){
    restraints.trimToSize();
    loads.trimToSize();
    pressures.trimToSize();
    temperature.trimToSize();
    htcs.trimToSize();
    Collections.sort(restraints,LABEL_COMPARATOR);
    Collections.sort(loads,LABEL_COMPARATOR);
    Collections.sort(pressures,LABEL_COMPARATOR);
    Collections.sort(temperature,LABEL_COMPARATOR);
    Collections.sort(htcs,LABEL_COMPARATOR);
  }

//--------------------------------------------------------------------//
/**
 * Si[XgԂ
 * @return Si[Xg
 */
  public ArrayList<Restraint> getRestraints(){
    return restraints;
  }

//--------------------------------------------------------------------//
/**
 * xŒi[XgԂ
 * @return xŒi[Xg
 */
  public ArrayList<Temperature> getTemperature(){
    return temperature;
  }

//--------------------------------------------------------------------//
/**
 * Eݒ肵ߓ_̃CfbNXݒ肷
 * @param nodeCount ߓ_
 * @param dof ߓ_̎Rxi[z
 * @return ߓ_Rx̍v
 */
  public int bcList(int nodeCount,int dof[]){
    this.nodeCount=nodeCount;
    this.dof=dof;
    nodeIndex=new int[nodeCount];
    int ii=0;
    for(int i=0;i<nodeCount;i++){
      nodeIndex[i]=ii;
      ii+=dof[i];
    }
    int restCount=restraintCount();
    bcList=new int[ii];
    Arrays.fill(bcList,-1);
    for(int i=0;i<restCount;i++){
      Restraint rest=getRestraint(i);
      int index0=nodeIndex[rest.label()];
      if(rest.restx) bcList[index0]=6*i;
      if(rest.resty) bcList[index0+1]=6*i+1;
      if(rest.restz) bcList[index0+2]=6*i+2;
      if(dof[rest.label()]==6){
      	if(rest.restrx) bcList[index0+3]=6*i+3;
      	if(rest.restry) bcList[index0+4]=6*i+4;
      	if(rest.restrz) bcList[index0+5]=6*i+5;
      }
    }
    return ii;
  }

//--------------------------------------------------------------------//
/**
 * M͋Eݒ肵ߓ_̃CfbNXݒ肷
 * @param nodeCount ߓ_
 * @return ߓ_Rx̍v
 */
  public int bcList(int nodeCount){
    this.nodeCount=nodeCount;
    int temperatureCount=temperatureCount();
    bcList=new int[nodeCount];
    Arrays.fill(bcList,-1);
    for(int i=0;i<temperatureCount;i++){
      Temperature temp=getTemperature(i);
      bcList[temp.label()]=i;
    }
    return temperatureCount;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_|C^Ԃ
 * @param index ߓ_̃CfbNX
 * @return ߓ_|C^
 */
  public int nodeIndex(int index){
    return nodeIndex[index];
  }

//--------------------------------------------------------------------//
/**
 * ߓ_RxԂ
 * @param index ߓ_̃CfbNX
 * @return ߓ_Rx
 */
  public int dof(int index){
    return dof[index];
  }

//--------------------------------------------------------------------//
/**
 * ׏dxNg쐬
 * @param dofAll fRx
 * @return ׏dxNg
 */
  public Vector loadVector(int dofAll){
    int loadCount=loadCount();
    Vector vector=new Vector(dofAll);
    for(int i=0;i<loadCount;i++){
      Load load=getLoad(i);
      int index0=nodeIndex[load.label()];
      vector.add(index0,load.x);
      vector.add(index0+1,load.y);
      vector.add(index0+2,load.z);
      if(dof[load.label()]==6){
      	vector.add(index0+3,load.rx);
      	vector.add(index0+4,load.ry);
      	vector.add(index0+5,load.rz);
      }
    }
    return vector;
  }

//--------------------------------------------------------------------//
/**
 * xxNg쐬
 * @param dofAll fRx
 * @return xxNg
 */
  public Vector tempVector(int dofAll){
    int temperatureCount=temperatureCount();
    Vector vector=new Vector(dofAll);
    for(int i=0;i<temperatureCount;i++){
      Temperature temp=getTemperature(i);
      vector.add(temp.label(),temp.temperature());
    }
    return vector;
  }
}
