package fem.bc;
import fem.LabeledData;
import figure.Vector3DR;

//--------------------------------------------------------------------//
/**
 * SNX
 */
public class Restraint extends Vector3DR implements LabeledData{

/** ߓ_x */
  public int node;

/** <i>x</i> ̍S̗L\ boolean ^ */
  public boolean restx;

/** <i>y</i> ̍S̗L\ boolean ^ */
  public boolean resty;

/** <i>z</i> ̍S̗L\ boolean ^ */
  public boolean restz;

/** <i>x</i> ̉]S̗L\ boolean ^ */
  public boolean restrx;

/** <i>y</i> ̉]S̗L\ boolean ^ */
  public boolean restry;

/** <i>z</i> ̉]S̗L\ boolean ^ */
  public boolean restrz;

/**
 * S\z
 * @param node ߓ_x
 */
  public Restraint(int node){
    this(node,true,true,true,true,true,true,0.0,0.0,0.0,0.0,0.0,0.0);
  }

/**
 * S\z
 * @param node ߓ_x
 * @param restx <i>x</i> ̍S̗L\ boolean ^
 * @param resty <i>y</i> ̍S̗L\ boolean ^
 * @param restz <i>z</i> ̍S̗L\ boolean ^
 * @param x ψʂ <i>x</i> 
 * @param y ψʂ <i>y</i> 
 * @param z ψʂ <i>z</i> 
 */
  public Restraint(int node,boolean restx,boolean resty,boolean restz,
      	      	   double x,double y,double z){
    this(node,restx,resty,restz,true,true,true,x,y,z,0.0,0.0,0.0);
  }

/**
 * S\z
 * @param node ߓ_x
 * @param restx <i>x</i> ̍S̗L\ boolean ^
 * @param resty <i>y</i> ̍S̗L\ boolean ^
 * @param restz <i>z</i> ̍S̗L\ boolean ^
 * @param restrx <i>x</i> ̉]S̗L\ boolean ^
 * @param restry <i>y</i> ̉]S̗L\ boolean ^
 * @param restrz <i>z</i> ̉]S̗L\ boolean ^
 * @param x ψʂ <i>x</i> 
 * @param y ψʂ <i>y</i> 
 * @param z ψʂ <i>z</i> 
 * @param rx ψʂ <i>x</i> ]
 * @param ry ψʂ <i>y</i> ]
 * @param rz ψʂ <i>z</i> ]
 */
  public Restraint(int node,boolean restx,boolean resty,boolean restz,
      	      	   boolean restrx,boolean restry,boolean restrz,
      	      	   double x,double y,double z,
      	      	   double rx,double ry,double rz){
    super(x,y,z,rx,ry,rz);
    this.restx=restx;
    this.resty=resty;
    this.restz=restz;
    this.restrx=restrx;
    this.restry=restry;
    this.restrz=restrz;
    this.node=node;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_xԂ
 * @return ߓ_x
 */
  public int label(){
    return node;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_xݒ肷
 * @param node ߓ_x
 */
  public void setLabel(int node){
    this.node=node;
  }

//--------------------------------------------------------------------//
/**
 * ψʂԂ
 * @param index ̃CfbNX
 * @return ψ
 */
  public double get(int index){
    switch(index){
      default:
      	return 0.0;
      case 0:
      	return x;
      case 1:
      	return y;
      case 2:
      	return z;
      case 3:
      	return rx;
      case 4:
      	return ry;
      case 5:
      	return rz;
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>Restraint</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof Restraint){
      if(!super.equals(obj)) return false;
      Restraint r=(Restraint)obj;
      return ((node==r.node)
      	   && (restx==r.restx)
      	   && (resty==r.resty)
      	   && (restz==r.restz)
      	   && (restrx==r.restrx)
      	   && (restry==r.restry)
      	   && (restrz==r.restrz));
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return toString(node);
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @param node ߓ_x
 * @return ̃IuWFNg̕\
 */
  public String toString(int node){
    int rex=0;
    int rey=0;
    int rez=0;
    int rerx=0;
    int rery=0;
    int rerz=0;
    if(restx) rex=1;
    if(resty) rey=1;
    if(restz) rez=1;
    if(restrx) rerx=1;
    if(restry) rery=1;
    if(restrz) rerz=1;
    return "Restraint\t"+node+"\t"
      	  +rex+"\t"+x+"\t"+rey+"\t"+y+"\t"+rez+"\t"+z+"\t"
      	  +rerx+"\t"+rx+"\t"+rery+"\t"+ry+"\t"+rerz+"\t"+rz;
  }
}
