package fem.border;
import fem.ElementBorder;
import figure.DefaultMatrix;
import figure.Matrix;
import figure.Point3D;
import figure.Vector;

//--------------------------------------------------------------------//
/**
 * lp`1vfENX
 */
public class QuadangleBorder1 extends AbstractElementBorder{

/** vfE */
  public static final String BORDER_NAME="QuadangleBorder1";

/** ߓ_ */
  public static final int NODE_COUNT=4;

  public QuadangleBorder1(int element,int p1,int p2,int p3,int p4){
    super(element);
    nodes=new int[NODE_COUNT];
    nodes[0]=p1;
    nodes[1]=p2;
    nodes[2]=p3;
    nodes[3]=p4;
  }

  public QuadangleBorder1(int element,int p[]){
    this(element,p[0],p[1],p[2],p[3]);
  }

//--------------------------------------------------------------------//
/**
 * vfÊԂ
 * @return vfE
 */
  public String getName(){
    return BORDER_NAME;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_Ԃ
 * @return ߓ_
 */
  public int nodeCount(){
    return NODE_COUNT;
  }

//--------------------------------------------------------------------//
/**
 * vfE𕪊
 * @return vfEi[z
 */
  public ElementBorder[] splitBorder(){
    return new ElementBorder[]{(ElementBorder)clone()};
  }

//--------------------------------------------------------------------//
/**
 * `֐s<br>
 * { <i>N<sub>i</sub></i>
 *   <i>dN<sub>i</sub></i> /<i>d</i>
 *   <i>dN<sub>i</sub></i> /<i>d</i> }<br>
 * Ԃ
 * @param xsi <i></i> W
 * @param eta <i></i> W
 */
  public Matrix shapeFunction(double xsi,double eta){
    Matrix m=new DefaultMatrix(NODE_COUNT,3);
    m.set(0,0,0.25*(1.0-xsi)*(1.0-eta));
    m.set(1,0,0.25*(1.0+xsi)*(1.0-eta));
    m.set(2,0,0.25*(1.0+xsi)*(1.0+eta));
    m.set(3,0,0.25*(1.0-xsi)*(1.0+eta));
    m.set(0,1,-0.25*(1.0-eta));
    m.set(1,1,0.25*(1.0-eta));
    m.set(2,1,0.25*(1.0+eta));
    m.set(3,1,-0.25*(1.0+eta));
    m.set(0,2,-0.25*(1.0-xsi));
    m.set(1,2,-0.25*(1.0+xsi));
    m.set(2,2,0.25*(1.0+xsi));
    m.set(3,2,0.25*(1.0-xsi));
    return m;
  }

//--------------------------------------------------------------------//
/**
 * `֐}gbNX<br>
 * { <i>N<sub>i</sub>N<sub>j</sub> dS</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return `֐}gbNX
 */
  public Matrix shapeFunctionMatrix(Point3D p[],double coef){
    Matrix s=new DefaultMatrix(NODE_COUNT);
    for(int i=0;i<4;i++){		// KEXϕ
      s.add(shapeFunctionMatrix(p,GX2[i%2],GX2[i/2]));
    }
    s.mul(coef);
    return s;
  }

//--------------------------------------------------------------------//
/**
 * `֐xNg<br>
 * { <i>N<sub>i</sub> dS</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return `֐xNg
 */
  public Vector shapeFunctionVector(Point3D p[],double coef){
    Vector s=new Vector(NODE_COUNT);
    for(int i=0;i<4;i++){		// KEXϕ
      s.add(shapeFunctionVector(p,GX2[i%2],GX2[i/2]));
    }
    s.mul(coef);
    return s;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @return rΏۂ̃IuWFNg <code>QuadangleBorder1</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof QuadangleBorder1){
      return super.equals(obj);
    }
    else{
      return false;
    }
  }
}
