package fem.border;
import fem.ElementBorder;
import figure.DefaultMatrix;
import figure.Matrix;
import figure.Point3D;
import figure.Vector;

//--------------------------------------------------------------------//
/**
 * Op`1vfENX
 */
public class TriangleBorder1 extends AbstractElementBorder{

/** vfE */
  public static final String BORDER_NAME="TriangleBorder1";

/** ߓ_ */
  public static final int NODE_COUNT=3;

  public TriangleBorder1(int element,int p1,int p2,int p3){
    super(element);
    nodes=new int[NODE_COUNT];
    nodes[0]=p1;
    nodes[1]=p2;
    nodes[2]=p3;
  }

  public TriangleBorder1(int element,int p[]){
    this(element,p[0],p[1],p[2]);
  }

//--------------------------------------------------------------------//
/**
 * vfÊԂ
 * @return vfE
 */
  public String getName(){
    return BORDER_NAME;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_Ԃ
 * @return ߓ_
 */
  public int nodeCount(){
    return NODE_COUNT;
  }

//--------------------------------------------------------------------//
/**
 * vfE𕪊
 * @return vfEi[z
 */
  public ElementBorder[] splitBorder(){
    return new ElementBorder[]{(ElementBorder)clone()};
  }

//--------------------------------------------------------------------//
/**
 * `֐s<br>
 * { <i>N<sub>i</sub></i>
 *   <i>dN<sub>i</sub></i> /<i>d</i>
 *   <i>dN<sub>i</sub></i> /<i>d</i> }<br>
 * Ԃ
 * @param xsi <i></i> W
 * @param eta <i></i> W
 */
  public Matrix shapeFunction(double xsi,double eta){
    Matrix m=new DefaultMatrix(NODE_COUNT,3);
    m.set(0,0,1.0-xsi-eta);
    m.set(1,0,xsi);
    m.set(2,0,eta);
    m.set(0,1,-1.0);
    m.set(1,1,1.0);
    m.set(0,2,-1.0);
    m.set(2,2,1.0);
    return m;
  }

//--------------------------------------------------------------------//
/**
 * RrAԂ
 * @param p ߓ_i[z
 * @return RrA
 */
  public double jacobian(Point3D p[]){
    double j1=(p[1].y-p[0].y)*(p[2].z-p[0].z)
      	     -(p[1].z-p[0].z)*(p[2].y-p[0].y);
    double j2=(p[1].z-p[0].z)*(p[2].x-p[0].x)
      	     -(p[1].x-p[0].x)*(p[2].z-p[0].z);
    double j3=(p[1].x-p[0].x)*(p[2].y-p[0].y)
      	     -(p[1].y-p[0].y)*(p[2].x-p[0].x);
    return Math.sqrt(j1*j1+j2*j2+j3*j3);
  }

//--------------------------------------------------------------------//
/**
 * `֐}gbNX<br>
 * { <i>N<sub>i</sub>N<sub>j</sub> dS</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return `֐}gbNX
 */
  public Matrix shapeFunctionMatrix(Point3D p[],double coef){
    Matrix s=new DefaultMatrix(NODE_COUNT);
    double value=coef*jacobian(p)/12.0;
    for(int i=0;i<NODE_COUNT;i++){
      s.set(i,i,value);
      for(int j=i+1;j<NODE_COUNT;j++){
      	s.set(i,j,0.5*value);
      	s.set(j,i,0.5*value);
      }
    }
    return s;
  }

//--------------------------------------------------------------------//
/**
 * `֐xNg<br>
 * { <i>N<sub>i</sub> dS</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return `֐xNg
 */
  public Vector shapeFunctionVector(Point3D p[],double coef){
    Vector s=new Vector(NODE_COUNT);
    double value=0.5*C1_3*coef*jacobian(p);
    for(int i=0;i<NODE_COUNT;i++){
      s.set(i,value);
    }
    return s;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @return rΏۂ̃IuWFNg <code>TriangleBorder1</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof TriangleBorder1){
      return super.equals(obj);
    }
    else{
      return false;
    }
  }
}
