package fem.border;
import fem.ElementBorder;
import figure.DefaultMatrix;
import figure.Matrix;
import figure.Point3D;
import figure.Vector;

//--------------------------------------------------------------------//
/**
 * Op`2vfENX
 */
public class TriangleBorder2 extends AbstractElementBorder{

/** vfE */
  public static final String BORDER_NAME="TriangleBorder2";

/** ߓ_ */
  public static final int NODE_COUNT=6;

/** ߓ_ <i></i> Wi[z */
  protected static final double XSI[]={0.0,1.0,0.0,0.5,0.5,0.0};

/** ߓ_ <i></i> Wi[z */
  protected static final double ETA[]={0.0,0.0,1.0,0.0,0.5,0.5};

/** RrA - ʐόW */
  protected static double S_COEF=1.0/6.0;

  public TriangleBorder2(int element,int p1,int p2,int p3,int p4,
      	      	      	 int p5,int p6){
    super(element);
    nodes=new int[NODE_COUNT];
    nodes[0]=p1;
    nodes[1]=p2;
    nodes[2]=p3;
    nodes[3]=p4;
    nodes[4]=p5;
    nodes[5]=p6;
  }

  public TriangleBorder2(int element,int p[]){
    this(element,p[0],p[1],p[2],p[3],p[4],p[5]);
  }

//--------------------------------------------------------------------//
/**
 * vfÊԂ
 * @return vfE
 */
  public String getName(){
    return BORDER_NAME;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_Ԃ
 * @return ߓ_
 */
  public int nodeCount(){
    return NODE_COUNT;
  }

//--------------------------------------------------------------------//
/**
 * 񏇂ɕ񂾐ߓ_xԂ
 * @return ߓ_x񏇂ɕׂĊi[z
 */
  public int[] cycleNodes(){
    return new int[]{nodes[0],nodes[3],nodes[1],nodes[4],nodes[2],
      	      	     nodes[5]};
  }

//--------------------------------------------------------------------//
/**
 * vfE𕪊
 * @return vfEi[z
 */
  public ElementBorder[] splitBorder(){
    return new ElementBorder[]
      {new TriangleBorder1(element,nodes[0],nodes[3],nodes[5]),
       new TriangleBorder1(element,nodes[1],nodes[4],nodes[3]),
       new TriangleBorder1(element,nodes[2],nodes[5],nodes[4]),
       new TriangleBorder1(element,nodes[3],nodes[4],nodes[5])};
  }

//--------------------------------------------------------------------//
/**
 * `֐s<br>
 * { <i>N<sub>i</sub></i>
 *   <i>dN<sub>i</sub></i> /<i>d</i>
 *   <i>dN<sub>i</sub></i> /<i>d</i> }<br>
 * Ԃ
 * @param xsi <i></i> W
 * @param eta <i></i> W
 */
  public Matrix shapeFunction(double xsi,double eta){
    Matrix m=new DefaultMatrix(NODE_COUNT,3);
    double xe=1.0-xsi-eta;
    m.set(0,0,xe*(2.0*xe-1.0));
    m.set(1,0,xsi*(2.0*xsi-1.0));
    m.set(2,0,eta*(2.0*eta-1.0));
    m.set(3,0,4.0*xe*xsi);
    m.set(4,0,4.0*xsi*eta);
    m.set(5,0,4.0*xe*eta);
    m.set(0,1,1.0-4.0*xe);
    m.set(1,1,4.0*xsi-1.0);
    m.set(3,1,4.0*(xe-xsi));
    m.set(4,1,4.0*eta);
    m.set(5,1,-4.0*eta);
    m.set(0,2,1.0-4.0*xe);
    m.set(2,2,4.0*eta-1.0);
    m.set(3,2,-4.0*xsi);
    m.set(4,2,4.0*xsi);
    m.set(5,2,4.0*(xe-eta));
    return m;
  }

//--------------------------------------------------------------------//
/**
 * `֐}gbNX<br>
 * { <i>N<sub>i</sub>N<sub>j</sub> dS</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return `֐}gbNX
 */
  public Matrix shapeFunctionMatrix(Point3D p[],double coef){
    Matrix s=new DefaultMatrix(NODE_COUNT);
    for(int i=0;i<3;i++){		// KEXϕ
      s.add(shapeFunctionMatrix(p,GTRI2[(int)XSI[i]],GTRI2[(int)ETA[i]]));
    }
    s.mul(S_COEF*coef);
    return s;
  }

//--------------------------------------------------------------------//
/**
 * `֐xNg<br>
 * { <i>N<sub>i</sub> dS</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return `֐xNg
 */
  public Vector shapeFunctionVector(Point3D p[],double coef){
    Vector s=new Vector(NODE_COUNT);
    for(int i=0;i<3;i++){		// KEXϕ
      s.add(shapeFunctionVector(p,GTRI2[(int)XSI[i]],GTRI2[(int)ETA[i]]));
    }
    s.mul(S_COEF*coef);
    return s;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @return rΏۂ̃IuWFNg <code>TriangleBorder2</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof TriangleBorder2){
      return super.equals(obj);
    }
    else{
      return false;
    }
  }
}
