package fem.component;
import java.awt.FlowLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import fem.AnalyzeType;
import fem.FEMDataModel;
import fem.result.Result;

//--------------------------------------------------------------------//
/**
 * pl
 */
public class FEMControlPanel extends Panel{

/** vZʂ̎ނi[z */
  public static final String
    PARAMS[]={"None","Displacement","Strain","Stress"};

/** x */
  public static final String TEMPERATURE="Temperature";

/** ψʂ̐i[z */
  public static final String
    DISP_COMPONENT[]={"Mag.","x","y","z"};

/** c̐i[z */
  public static final String
    STRAIN_COMPONENT[]={"Max.prin. 1","Min.prin. 1","Mid.prin. 1",
      	      	      	"Max.share 1",
      	      	      	"x 1","y 1","z 1","xy 1","yz 1","zx 1",
      	      	      	"Max.prin. 2","Min.prin. 2","Mid.prin. 2",
      	      	      	"Max.share 2",
      	      	      	"x 2","y 2","z 2","xy 2","yz 2","zx 2"};

/** ͂̐i[z */
  public static final String
    STRESS_COMPONENT[]={"Max.prin. 1","Min.prin. 1","Mid.prin. 1",
      	      	      	"Max.share 1","Von mises 1",
      	      	      	"x 1","y 1","z 1","xy 1","yz 1","zx 1",
      	      	      	"Max.prin. 2","Min.prin. 2","Mid.prin. 2",
      	      	      	"Max.share 2","Von mises 2",
      	      	      	"x 2","y 2","z 2","xy 2","yz 2","zx 2"};

/** ψʕ\{\ */
  public static final String DISP_COEF="Disp. coef.";

/** \LoX */
  protected FEMViewCanvas canvas;

/** R^[\f[^̎ނ\ int ^ */
  protected int contourParam;

/** vZʂ̎ނ\Ɛl֘At}bv */
  protected HashMap<String,Integer> parameterMap;

/** vZʂ̐\Ɛl֘At}bv */
  protected HashMap<String,Integer> componentMap;

/** vZ{^ */
  protected CalculateButton calc;

/** vZʏ{^ */
  protected ClearResultButton clear;

/** ψʕ\{̓tB[h */
  protected TextField dispCoefField;

/** \ʐIj[ */
  protected ResultChoice res;

/** \ψʐIj[ */
  protected ResultCompChoice disp;

/** \cIj[ */
  protected ResultCompChoice strain;

/** \͐Ij[ */
  protected ResultCompChoice stress;

/**
 * plg\z
 * @param canvas \LoX
 */
  public FEMControlPanel(FEMViewCanvas canvas){
    super(new FlowLayout());
    this.canvas=canvas;
    contourParam=Result.NONE;
    calc=new CalculateButton(this);
    clear=new ClearResultButton(canvas);
    add(calc);
    add(clear);
    switch(canvas.getModel().getAnalyzeType()){
      case STRUCTURE:
      	dispCoefField=new TextField("0.1",8);
      	dispCoefField.addActionListener(new DispCoefAction());
      	disp=new ResultCompChoice(this,DISP_COMPONENT);
      	strain=new ResultCompChoice(this,STRAIN_COMPONENT);
      	stress=new ResultCompChoice(this,STRESS_COMPONENT);
      	add(new Label(DISP_COEF));
      	add(dispCoefField);
      	break;
    }
    res=new ResultChoice(this);
    add(res);
    setMaps();
  }

//--------------------------------------------------------------------//
/**
 * }bvݒ肷
 */
  protected void setMaps(){
    parameterMap=new HashMap<String,Integer>();
    parameterMap.put(PARAMS[0],Result.NONE);

    componentMap=new HashMap<String,Integer>();
    switch(canvas.getModel().getAnalyzeType()){
      case STRUCTURE:
      	parameterMap.put(PARAMS[1],Result.DISPLACEMENT);
      	parameterMap.put(PARAMS[2],Result.STRAIN);
      	parameterMap.put(PARAMS[3],Result.STRESS);
      	componentMap.put("x",Result.X);
      	componentMap.put("y",Result.Y);
      	componentMap.put("z",Result.Z);
      	componentMap.put("Mag.",Result.MAGNITUDE);
      	componentMap.put("x 1",Result.X);
      	componentMap.put("y 1",Result.Y);
      	componentMap.put("z 1",Result.Z);
      	componentMap.put("xy 1",Result.XY);
      	componentMap.put("yz 1",Result.YZ);
      	componentMap.put("zx 1",Result.ZX);
      	componentMap.put("Max.prin. 1",Result.MAX_PRINCIPAL);
      	componentMap.put("Min.prin. 1",Result.MIN_PRINCIPAL);
      	componentMap.put("Mid.prin. 1",Result.MID_PRINCIPAL);
      	componentMap.put("Max.share 1",Result.MAX_SHARE);
      	componentMap.put("Von mises 1",Result.VON_MISES);
      	componentMap.put("x 2",Result.X+Result.SHIFT);
      	componentMap.put("y 2",Result.Y+Result.SHIFT);
      	componentMap.put("z 2",Result.Z+Result.SHIFT);
      	componentMap.put("xy 2",Result.XY+Result.SHIFT);
      	componentMap.put("yz 2",Result.YZ+Result.SHIFT);
      	componentMap.put("zx 2",Result.ZX+Result.SHIFT);
      	componentMap.put("Max.prin. 2",Result.MAX_PRINCIPAL+Result.SHIFT);
      	componentMap.put("Min.prin. 2",Result.MIN_PRINCIPAL+Result.SHIFT);
      	componentMap.put("Mid.prin. 2",Result.MID_PRINCIPAL+Result.SHIFT);
      	componentMap.put("Max.share 2",Result.MAX_SHARE+Result.SHIFT);
      	componentMap.put("Von mises 2",Result.VON_MISES+Result.SHIFT);
      	break;
      case HEAT_TRANSFER:
      	parameterMap.put(TEMPERATURE,Result.TEMPERATURE);
      	break;
    }
  }

//--------------------------------------------------------------------//
/**
 * FEM f[^fԂ
 * @return FEM f[^f
 */
  public FEMDataModel getModel(){
    return canvas.getModel();
  }

//--------------------------------------------------------------------//
/**
 * \LoXԂ
 * @return \LoX
 */
  public FEMViewCanvas getViewCanvas(){
    return canvas;
  }

//--------------------------------------------------------------------//
/**
 * R^[\f[^̎ނݒ肷
 * @param value f[^
 */
  public void setContourParam(String value){
    Integer param=parameterMap.get(value);
    if(param==null) return;
    contourParam=param.intValue();
    switch(canvas.getModel().getAnalyzeType()){
      case STRUCTURE:
      	removeAll();
      	add(calc);
      	add(clear);
      	add(new Label(DISP_COEF));
      	add(dispCoefField);
      	add(res);
      	switch(contourParam){
      	  case Result.NONE:
      	    canvas.setContour(contourParam,0);
      	    break;
      	  case Result.DISPLACEMENT:
      	    add(disp);
      	    setComponent((String)disp.getSelectedItem());
      	    break;
      	  case Result.STRAIN:
      	    add(strain);
      	    setComponent((String)strain.getSelectedItem());
      	    break;
      	  case Result.STRESS:
      	    add(stress);
      	    setComponent((String)stress.getSelectedItem());
      	    break;
      	}
      	validate();
      	break;
      case HEAT_TRANSFER:
      	canvas.setContour(contourParam,0);
      	break;
    }
  }

//--------------------------------------------------------------------//
/**
 * \錋ʂ̐I
 * @param value 
 */
  public void setComponent(String value){
    Integer comp=componentMap.get(value);
    if(comp!=null){
      canvas.setContour(contourParam,comp.intValue());
    }
  }

//--------------------------------------------------------------------//
/**
 * ό`{ݒ肷
 */
  public void setDispCoef(){
    try{
      double cc=Double.parseDouble(dispCoefField.getText());
      canvas.setDisplacementCoef(canvas.getDisplacementViewCoef(cc));
    }
    catch(Exception ex){
    }
  }

//--------------------------------------------------------------------//
/**
 * ANV{^
 */
  protected class DispCoefAction implements ActionListener{

//--------------------------------------------------------------------//
/**
 * ANVs
 * @param e ANVƂCxg
 */
    public void actionPerformed(ActionEvent e){
      setDispCoef();
    }
  }
}
