package fem.element;
import java.util.Arrays;
import fem.AbstractNodes;
import fem.Element;
import fem.ElementBorder;
import fem.Material;
import figure.Matrix;
import figure.Point3D;
import figure.Vector;
import figure.Vector3D;
import figure.Vector3DR;

//--------------------------------------------------------------------//
/**
 * vf̒ۃX[p[NX
 */
public abstract class AbstractElement extends AbstractNodes
  implements Cloneable,Element{

/** vfx */
  protected int label;

/** ޗ̃CfbNX */
  protected int material;

/**
 * vf\z
 * @param label vfx
 * @param material ޗ̃CfbNX
 */
  protected AbstractElement(int label,int material){
    this.label=label;
    this.material=material;
  }

//--------------------------------------------------------------------//
/**
 * vf̂Ԃ
 * @return vf
 */
  public abstract String getName();

//--------------------------------------------------------------------//
/**
 * vfxԂ
 * @return vfx
 */
  public int label(){
    return label;
  }

//--------------------------------------------------------------------//
/**
 * vfxݒ肷
 * @param label vfx
 */
  public void setLabel(int label){
    this.label=label;
  }

//--------------------------------------------------------------------//
/**
 * ޗ̃CfbNXԂ
 * @return ޗ̃CfbNX
 */
  public int getMaterial(){
    return material;
  }

//--------------------------------------------------------------------//
/**
 * ޗ̃CfbNXݒ肷
 * @param material ޗ̃CfbNX
 */
  public void setMaterial(int material){
    this.material=material;
  }

//--------------------------------------------------------------------//
/**
 * vfEԂ
 * @param element vfx
 * @return vfEi[z
 */
  public ElementBorder[] borders(int element){
    int borderCount=borderCount();
    ElementBorder borders[]=new ElementBorder[borderCount];
    for(int i=0;i<borderCount;i++) borders[i]=border(element,i);
    return borders;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_ψʂxNgɕϊ
 * @param d ߓ_ψʂi[z
 * @return ߓ_ψʂ\xNg
 */
  protected Vector toVector(Vector3D d[]){
    int nodeCount=nodeCount();
    Vector v=new Vector(3*nodeCount);
    for(int i=0;i<nodeCount;i++){
      int i3=3*i;
      v.set(i3,d[i].x);
      v.set(i3+1,d[i].y);
      v.set(i3+2,d[i].z);
    }
    return v;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_ψʂxNgɕϊ
 * @param d ߓ_ψʂi[z
 * @return ߓ_ψʂ\xNg
 */
  protected Vector toVector(Vector3DR d[]){
    int nodeCount=nodeCount();
    Vector v=new Vector(6*nodeCount);
    for(int i=0;i<nodeCount;i++){
      int i6=6*i;
      v.set(i6,d[i].x);
      v.set(i6+1,d[i].y);
      v.set(i6+2,d[i].z);
      v.set(i6+3,d[i].rx);
      v.set(i6+4,d[i].ry);
      v.set(i6+5,d[i].rz);
    }
    return v;
  }

//--------------------------------------------------------------------//
/**
 * ʃ}gbNXԂ
 * @param p ߓ_i[z
 * @param material ޗ
 * @return ʃ}gbNX
 */
  public Matrix massMatrix(Point3D p[],Material material){
    return massMatrix(p,material.density);
  }

//--------------------------------------------------------------------//
/**
 * }gbNXԂ
 * @param p ߓ_i[z
 * @param material ޗ
 * @return }gbNX
 */
  public Matrix stiffnessMatrix(Point3D p[],Material material){
    return stiffnessMatrix(p,material.matrix());
  }

//--------------------------------------------------------------------//
/**
 * `֐}gbNX<br>
 * { <i>N<sub>i</sub>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param material ޗ
 * @return `֐}gbNX
 */
  public Matrix shapeFunctionMatrix(Point3D p[],Material material){
    return shapeFunctionMatrix(p,material.cv);
  }

//--------------------------------------------------------------------//
/**
 * gU}gbNX<br>
 * { <i>N<sub>i</sub></i>E<i>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param material ޗ
 * @return gU}gbNX
 */
  public Matrix gradMatrix(Point3D p[],Material material){
    return gradMatrix(p,material.heatConductivity);
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    return copyElement();
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Element copyElement(){
    try{
      AbstractElement element=(AbstractElement)super.clone();
      element.nodes=new int[nodes.length];
      System.arraycopy(nodes,0,element.nodes,0,nodes.length);
      return element;
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    int bit=31*label+material;
    for(int i=0;i<nodes.length;i++){
      bit=31*bit+nodes[i];
    }
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>AbstractElement</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof AbstractElement){
      AbstractElement elem=(AbstractElement)obj;
      int nodes[]=elem.nodes();
      return ((label==elem.label)
      	   && (material==elem.material)
      	   && Arrays.equals(nodes,elem.nodes));
    }
    else{
      return false;
    }
  }
}
