package fem.element;
import fem.ElementBorder;
import fem.border.QuadangleBorder2;
import fem.result.Strain;
import fem.result.Stress;
import figure.DefaultMatrix;
import figure.Matrix;
import figure.Point3D;
import figure.Vector;
import figure.Vector3D;

//--------------------------------------------------------------------//
/**
 * Zʑ̃ZfBseB 2 vfNX
 */
public class HexaElement2 extends AbstractSolidElement{

/** vf */
  public static final String ELEMENT_NAME="HexaElement2";

/** ߓ_ */
  public static final int NODE_COUNT=20;

/** vfE */
  public static final int BORDER_COUNT=6;

/** ߓ_ <i></i> Wi[z */
  protected static final double
    XSI[]={-1.0,1.0,1.0,-1.0,-1.0,1.0,1.0,-1.0,0.0,1.0,0.0,-1.0,
      	   0.0,1.0,0.0,-1.0,-1.0,1.0,1.0,-1.0};

/** ߓ_ <i></i> Wi[z */
  protected static final double
    ETA[]={-1.0,-1.0,1.0,1.0,-1.0,-1.0,1.0,1.0,-1.0,0.0,1.0,0.0,
      	   -1.0,0.0,1.0,0.0,-1.0,-1.0,1.0,1.0};

/** ߓ_ <i></i> Wi[z */
  protected static final double
    ZETA[]={-1.0,-1.0,-1.0,-1.0,1.0,1.0,1.0,1.0,-1.0,-1.0,-1.0,-1.0,
      	    1.0,1.0,1.0,1.0,0.0,0.0,0.0,0.0};

/** ߓ_pxȂߓ_̃CfbNXi[z */
  protected static final int ANGLE[][]=
    {{8,11,16},{9,8,17},{10,9,18},{11,10,19},
     {12,15,16},{13,12,17},{14,13,18},{15,14,19},
     {12,10},{13,11},{14,8},{15,9},{8,14},{9,15},{10,12},{11,13},
     {17,19},{16,18},{17,19},{16,18}};

/**
 * vf\z
 * @param label vfx
 * @param material ޗԍ
 */
  public HexaElement2(int label,int material,int p1,int p2,int p3,int p4,
      	      	      int p5,int p6,int p7,int p8,int p9,int p10,
      	      	      int p11,int p12,int p13,int p14,int p15,int p16,
      	      	      int p17,int p18,int p19,int p20){
    super(label,material);
    nodes=new int[20];
    nodes[0]=p1;
    nodes[1]=p2;
    nodes[2]=p3;
    nodes[3]=p4;
    nodes[4]=p5;
    nodes[5]=p6;
    nodes[6]=p7;
    nodes[7]=p8;
    nodes[8]=p9;
    nodes[9]=p10;
    nodes[10]=p11;
    nodes[11]=p12;
    nodes[12]=p13;
    nodes[13]=p14;
    nodes[14]=p15;
    nodes[15]=p16;
    nodes[16]=p17;
    nodes[17]=p18;
    nodes[18]=p19;
    nodes[19]=p20;
  }

/**
 * vf\z
 * @param label vfx
 * @param material ޗԍ
 * @param p ߓ_ԍi[z
 */
  public HexaElement2(int label,int material,int p[]){
    this(label,material,p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8],
      	 p[9],p[10],p[11],p[12],p[13],p[14],p[15],p[16],p[17],p[18],
      	 p[19]);
  }

//--------------------------------------------------------------------//
/**
 * vf̂Ԃ
 * @return vf
 */
  public String getName(){
    return ELEMENT_NAME;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_Ԃ
 * @return ߓ_
 */
  public int nodeCount(){
    return NODE_COUNT;
  }

//--------------------------------------------------------------------//
/**
 * vfEԂ
 * @return vfE
 */
  public int borderCount(){
    return BORDER_COUNT;
  }

//--------------------------------------------------------------------//
/**
 * vfEԂ
 * @param element vfx
 * @param index vfẼCfbNX
 * @return vfEi[z
 */
  public ElementBorder border(int element,int index){
    switch(index){
      default:
      	return null;
      case 0:
      	return new QuadangleBorder2(element,nodes[0],nodes[3],nodes[2],
      	      	      	      	    nodes[1],nodes[11],nodes[10],
      	      	      	      	    nodes[9],nodes[8]);
      case 1:
      	return new QuadangleBorder2(element,nodes[4],nodes[5],nodes[6],
      	      	      	      	    nodes[7],nodes[12],nodes[13],
      	      	      	      	    nodes[14],nodes[15]);
      case 2:
      	return new QuadangleBorder2(element,nodes[0],nodes[1],nodes[5],
      	      	      	      	    nodes[4],nodes[8],nodes[17],
      	      	      	      	    nodes[12],nodes[16]);
      case 3:
      	return new QuadangleBorder2(element,nodes[1],nodes[2],nodes[6],
      	      	      	      	    nodes[5],nodes[9],nodes[18],
      	      	      	      	    nodes[13],nodes[17]);
      case 4:
      	return new QuadangleBorder2(element,nodes[2],nodes[3],nodes[7],
      	      	      	      	    nodes[6],nodes[10],nodes[19],
      	      	      	      	    nodes[14],nodes[18]);
      case 5:
      	return new QuadangleBorder2(element,nodes[3],nodes[0],nodes[4],
      	      	      	      	    nodes[7],nodes[11],nodes[16],
      	      	      	      	    nodes[15],nodes[19]);
    }
  }

//--------------------------------------------------------------------//
/**
 * vfߓ_̊pxԂ
 * @param p ߓ_i[z
 * @return vfߓ_̊pxi[z
 */
  public double[] angle(Point3D p[]){
    double angle[]=new double[NODE_COUNT];
    for(int i=0;i<8;i++){
      angle[i]=Vector3D.angle(new Vector3D(p[i],p[ANGLE[i][0]]),
      	      	      	      new Vector3D(p[i],p[ANGLE[i][1]]),
      	      	      	      new Vector3D(p[i],p[ANGLE[i][2]]));
    }
    for(int i=8;i<20;i++){
      angle[i]=Vector3D.angle(new Vector3D(p[i],p[ANGLE[i][0]]),
      	      	      	      new Vector3D(p[i],p[ANGLE[i][1]]));
    }
    return angle;
  }

//--------------------------------------------------------------------//
/**
 * `֐s<br>
 * { <i>N<sub>i</sub></i>
 *   <i>dN<sub>i</sub></i> /<i>d</i>
 *   <i>dN<sub>i</sub></i> /<i>d</i>
 *   <i>dN<sub>i</sub></i> /<i>d</i> }<br>
 * Ԃ
 * @param xsi <i></i> W
 * @param eta <i></i> W
 * @param zeta <i></i> W
 * @return `֐s
 */
  public Matrix shapeFunction(double xsi,double eta,double zeta){
    Matrix m=new DefaultMatrix(NODE_COUNT,4);
    m.set(0,0,0.125*(1.0-xsi)*(1.0-eta)*(1.0-zeta)*(-xsi-eta-zeta-1.0));
    m.set(1,0,0.125*(1.0+xsi)*(1.0-eta)*(1.0-zeta)*(xsi-eta-zeta-1.0));
    m.set(2,0,0.125*(1.0+xsi)*(1.0+eta)*(1.0-zeta)*(xsi+eta-zeta-1.0));
    m.set(3,0,0.125*(1.0-xsi)*(1.0+eta)*(1.0-zeta)*(-xsi+eta-zeta-1.0));
    m.set(4,0,0.125*(1.0-xsi)*(1.0-eta)*(1.0+zeta)*(-xsi-eta+zeta-1.0));
    m.set(5,0,0.125*(1.0+xsi)*(1.0-eta)*(1.0+zeta)*(xsi-eta+zeta-1.0));
    m.set(6,0,0.125*(1.0+xsi)*(1.0+eta)*(1.0+zeta)*(xsi+eta+zeta-1.0));
    m.set(7,0,0.125*(1.0-xsi)*(1.0+eta)*(1.0+zeta)*(-xsi+eta+zeta-1.0));
    m.set(8,0,0.25*(1.0+xsi)*(1.0-xsi)*(1.0-eta)*(1.0-zeta));
    m.set(9,0,0.25*(1.0+xsi)*(1.0+eta)*(1.0-eta)*(1.0-zeta));
    m.set(10,0,0.25*(1.0+xsi)*(1.0-xsi)*(1.0+eta)*(1.0-zeta));
    m.set(11,0,0.25*(1.0-xsi)*(1.0+eta)*(1.0-eta)*(1.0-zeta));
    m.set(12,0,0.25*(1.0+xsi)*(1.0-xsi)*(1.0-eta)*(1.0+zeta));
    m.set(13,0,0.25*(1.0+xsi)*(1.0+eta)*(1.0-eta)*(1.0+zeta));
    m.set(14,0,0.25*(1.0+xsi)*(1.0-xsi)*(1.0+eta)*(1.0+zeta));
    m.set(15,0,0.25*(1.0-xsi)*(1.0+eta)*(1.0-eta)*(1.0+zeta));
    m.set(16,0,0.25*(1.0-xsi)*(1.0-eta)*(1.0+zeta)*(1.0-zeta));
    m.set(17,0,0.25*(1.0+xsi)*(1.0-eta)*(1.0+zeta)*(1.0-zeta));
    m.set(18,0,0.25*(1.0+xsi)*(1.0+eta)*(1.0+zeta)*(1.0-zeta));
    m.set(19,0,0.25*(1.0-xsi)*(1.0+eta)*(1.0+zeta)*(1.0-zeta));
    m.set(0,1,0.125*(1.0-eta)*(1.0-zeta)*(2.0*xsi+eta+zeta));
    m.set(1,1,0.125*(1.0-eta)*(1.0-zeta)*(2.0*xsi-eta-zeta));
    m.set(2,1,0.125*(1.0+eta)*(1.0-zeta)*(2.0*xsi+eta-zeta));
    m.set(3,1,0.125*(1.0+eta)*(1.0-zeta)*(2.0*xsi-eta+zeta));
    m.set(4,1,0.125*(1.0-eta)*(1.0+zeta)*(2.0*xsi+eta-zeta));
    m.set(5,1,0.125*(1.0-eta)*(1.0+zeta)*(2.0*xsi-eta+zeta));
    m.set(6,1,0.125*(1.0+eta)*(1.0+zeta)*(2.0*xsi+eta+zeta));
    m.set(7,1,0.125*(1.0+eta)*(1.0+zeta)*(2.0*xsi-eta-zeta));
    m.set(8,1,-0.5*xsi*(1.0-eta)*(1.0-zeta));
    m.set(9,1,0.25*(1.0+eta)*(1.0-eta)*(1.0-zeta));
    m.set(10,1,-0.5*xsi*(1.0+eta)*(1.0-zeta));
    m.set(11,1,-0.25*(1.0+eta)*(1.0-eta)*(1.0-zeta));
    m.set(12,1,-0.5*xsi*(1.0-eta)*(1.0+zeta));
    m.set(13,1,0.25*(1.0+eta)*(1.0-eta)*(1.0+zeta));
    m.set(14,1,-0.5*xsi*(1.0+eta)*(1.0+zeta));
    m.set(15,1,-0.25*(1.0+eta)*(1.0-eta)*(1.0+zeta));
    m.set(16,1,-0.25*(1.0-eta)*(1.0+zeta)*(1.0-zeta));
    m.set(17,1,0.25*(1.0-eta)*(1.0+zeta)*(1.0-zeta));
    m.set(18,1,0.25*(1.0+eta)*(1.0+zeta)*(1.0-zeta));
    m.set(19,1,-0.25*(1.0+eta)*(1.0+zeta)*(1.0-zeta));
    m.set(0,2,0.125*(1.0-xsi)*(1.0-zeta)*(xsi+2.0*eta+zeta));
    m.set(1,2,0.125*(1.0+xsi)*(1.0-zeta)*(-xsi+2.0*eta+zeta));
    m.set(2,2,0.125*(1.0+xsi)*(1.0-zeta)*(xsi+2.0*eta-zeta));
    m.set(3,2,0.125*(1.0-xsi)*(1.0-zeta)*(-xsi+2.0*eta-zeta));
    m.set(4,2,0.125*(1.0-xsi)*(1.0+zeta)*(xsi+2.0*eta-zeta));
    m.set(5,2,0.125*(1.0+xsi)*(1.0+zeta)*(-xsi+2.0*eta-zeta));
    m.set(6,2,0.125*(1.0+xsi)*(1.0+zeta)*(xsi+2.0*eta+zeta));
    m.set(7,2,0.125*(1.0-xsi)*(1.0+zeta)*(-xsi+2.0*eta+zeta));
    m.set(8,2,-0.25*(1.0+xsi)*(1.0-xsi)*(1.0-zeta));
    m.set(9,2,-0.5*(1.0+xsi)*eta*(1.0-zeta));
    m.set(10,2,0.25*(1.0+xsi)*(1.0-xsi)*(1.0-zeta));
    m.set(11,2,-0.5*(1.0-xsi)*eta*(1.0-zeta));
    m.set(12,2,-0.25*(1.0+xsi)*(1.0-xsi)*(1.0+zeta));
    m.set(13,2,-0.5*(1.0+xsi)*eta*(1.0+zeta));
    m.set(14,2,0.25*(1.0+xsi)*(1.0-xsi)*(1.0+zeta));
    m.set(15,2,-0.5*(1.0-xsi)*eta*(1.0+zeta));
    m.set(16,2,-0.25*(1.0-xsi)*(1.0+zeta)*(1.0-zeta));
    m.set(17,2,-0.25*(1.0+xsi)*(1.0+zeta)*(1.0-zeta));
    m.set(18,2,0.25*(1.0+xsi)*(1.0+zeta)*(1.0-zeta));
    m.set(19,2,0.25*(1.0-xsi)*(1.0+zeta)*(1.0-zeta));
    m.set(0,3,0.125*(1.0-xsi)*(1.0-eta)*(xsi+eta+2.0*zeta));
    m.set(1,3,0.125*(1.0+xsi)*(1.0-eta)*(-xsi+eta+2.0*zeta));
    m.set(2,3,0.125*(1.0+xsi)*(1.0+eta)*(-xsi-eta+2.0*zeta));
    m.set(3,3,0.125*(1.0-xsi)*(1.0+eta)*(xsi-eta+2.0*zeta));
    m.set(4,3,0.125*(1.0-xsi)*(1.0-eta)*(-xsi-eta+2.0*zeta));
    m.set(5,3,0.125*(1.0+xsi)*(1.0-eta)*(xsi-eta+2.0*zeta));
    m.set(6,3,0.125*(1.0+xsi)*(1.0+eta)*(xsi+eta+2.0*zeta));
    m.set(7,3,0.125*(1.0-xsi)*(1.0+eta)*(-xsi+eta+2.0*zeta));
    m.set(8,3,-0.25*(1.0+xsi)*(1.0-xsi)*(1.0-eta));
    m.set(9,3,-0.25*(1.0+xsi)*(1.0+eta)*(1.0-eta));
    m.set(10,3,-0.25*(1.0+xsi)*(1.0-xsi)*eta);
    m.set(11,3,-0.25*(1.0-xsi)*(1.0+eta)*(1.0-eta));
    m.set(12,3,0.25*(1.0+xsi)*(1.0-xsi)*(1.0-eta));
    m.set(13,3,0.25*(1.0+xsi)*(1.0+eta)*(1.0-eta));
    m.set(14,3,0.25*(1.0+xsi)*(1.0-xsi)*eta);
    m.set(15,3,0.25*(1.0-xsi)*(1.0+eta)*(1.0-eta));
    m.set(16,3,-0.5*(1.0-xsi)*(1.0-eta)*zeta);
    m.set(17,3,-0.5*(1.0+xsi)*(1.0-eta)*zeta);
    m.set(18,3,-0.5*(1.0+xsi)*(1.0+eta)*zeta);
    m.set(19,3,-0.5*(1.0-xsi)*(1.0+eta)*zeta);
    return m;
  }

//--------------------------------------------------------------------//
/**
 * ʃ}gbNXԂ
 * @param p ߓ_i[z
 * @param density ޗ̖x
 * @return ʃ}gbNX
 */
  public Matrix massMatrix(Point3D p[],double density){
    Matrix m=new DefaultMatrix(3*NODE_COUNT);
    for(int i=0;i<27;i++){              // KEXϕ
      int ii1=i%3;
      int ii2=(i/3)%3;
      int ii3=i/9;
      double dw=GW3[ii1]*GW3[ii2]*GW3[ii3];
      Matrix sf=shapeFunction(GX3[ii1],GX3[ii2],GX3[ii3]);
      Matrix jacob=jacobianMatrix(p,sf);
      double jacobian=dw*jacobian(jacob);
      Matrix ms=new DefaultMatrix(60);

      for(int i1=0;i1<NODE_COUNT;i1++){
      	for(int j1=0;j1<NODE_COUNT;j1++){
      	  double value=jacobian*sf.get(i1,0)*sf.get(j1,0);
      	  int i3=3*i1;
      	  int j3=3*j1;
      	  ms.set(i3,j3,value);
      	  ms.set(i3+1,j3+1,value);
      	  ms.set(i3+2,j3+2,value);
      	}
      }
      m.add(ms);
    }
    m.mul(density*0.125);
    return m;
  }

//--------------------------------------------------------------------//
/**
 * }gbNXԂ
 * @param p ߓ_i[z
 * @param d1  - c}gbNX
 * @return }gbNX
 */
  public Matrix stiffnessMatrix(Point3D p[],Matrix d1){
    Matrix k=new DefaultMatrix(3*NODE_COUNT);
    for(int i=0;i<27;i++){              // KEXϕ
      int i1=i%3;
      int i2=(i/3)%3;
      int i3=i/9;
      k.add(stiffnessMatrix(p,d1,GX3[i1],GX3[i2],GX3[i3],
      	      	      	    GW3[i1]*GW3[i2]*GW3[i3]));
    }
    return k;
  }

//--------------------------------------------------------------------//
/**
 * vfcԂ
 * @param p ߓ_i[z
 * @param d ߓ_ψʂi[z
 * @return vfci[z
 */
  public Strain[] strain(Point3D p[],Vector3D d[]){
    return strain(p,d,XSI,ETA,ZETA);
  }

//--------------------------------------------------------------------//
/**
 * vf͂Ԃ
 * @param p ߓ_i[z
 * @param d ߓ_ψʂi[z
 * @param d1  - c}gbNX
 * @return vf͂i[z
 */
  public Stress[] stress(Point3D p[],Vector3D d[],Matrix d1){
    return stress(p,d,d1,XSI,ETA,ZETA);
  }

//--------------------------------------------------------------------//
/**
 * `֐}gbNX<br>
 * { <i>N<sub>i</sub>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return `֐}gbNX
 */
  public Matrix shapeFunctionMatrix(Point3D p[],double coef){
    Matrix s=new DefaultMatrix(NODE_COUNT);
    for(int i=0;i<27;i++){		// KEXϕ
      int i1=i%3;
      int i2=(i/3)%3;
      int i3=i/9;
      s.add(shapeFunctionMatrix(p,GX3[i1],GX3[i2],GX3[i3],
      	      	      	      	coef*GW3[i1]*GW3[i2]*GW3[i3]));
    }
    return s;
  }

//--------------------------------------------------------------------//
/**
 * gU}gbNX<br>
 * { <i>N<sub>i</sub></i>E<i>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return gU}gbNX
 */
  public Matrix gradMatrix(Point3D p[],double coef){
    Matrix g=new DefaultMatrix(NODE_COUNT);
    for(int i=0;i<27;i++){		// KEXϕ
      int i1=i%3;
      int i2=(i/3)%3;
      int i3=i/9;
      g.add(gradMatrix(p,GX3[i1],GX3[i2],GX3[i3],
      	      	       coef*GW3[i1]*GW3[i2]*GW3[i3]));
    }
    return g;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @return rΏۂ̃IuWFNg <code>HexaElement2</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof HexaElement2){
      return super.equals(obj);
    }
    else{
      return false;
    }
  }
}
