package fem.element;
import fem.ElementBorder;
import fem.border.TriangleBorder2;
import fem.border.QuadangleBorder2;
import fem.result.Strain;
import fem.result.Stress;
import figure.DefaultMatrix;
import figure.Matrix;
import figure.Point3D;
import figure.Vector;
import figure.Vector3D;

//--------------------------------------------------------------------//
/**
 * ` 2 vfNX
 */
public class WedgeElement2 extends AbstractSolidElement{

/** vf */
  public static final String ELEMENT_NAME="WedgeElement2";

/** ߓ_ */
  public static final int NODE_COUNT=15;

/** vfE */
  public static final int BORDER_COUNT=5;

/** ߓ_ <i></i> Wi[z */
  protected static final double
    XSI[]={0.0,1.0,0.0,0.0,1.0,0.0,0.5,0.5,0.0,0.5,0.5,0.0,0.0,1.0,0.0};

/** ߓ_ <i></i> Wi[z */
  protected static final double
    ETA[]={0.0,0.0,1.0,0.0,0.0,1.0,0.0,0.5,0.5,0.0,0.5,0.5,0.0,0.0,1.0};

/** ߓ_ <i></i> Wi[z */
  protected static final double
    ZETA[]={-1.0,-1.0,-1.0,1.0,1.0,1.0,-1.0,-1.0,-1.0,1.0,1.0,1.0,
      	    0.0,0.0,0.0};

/** ߓ_pxȂߓ_̃CfbNXi[z */
  protected static final int ANGLE[][]=
    {{6,8,12},{6,7,13},{7,8,14},{9,11,12},{10,9,13},{11,10,14},
     {2,9},{0,10},{1,11},{6,5},{7,3},{8,4},{13,14},{14,12},{12,13}};

/** RrA - ̐όW */
  protected static double V_COEF=1.0/6.0;

/**
 * vf\z
 * @param label vfx
 * @param material ޗԍ
 */
  public WedgeElement2(int label,int material,int p1,int p2,int p3,int p4,
      	      	       int p5,int p6,int p7,int p8,int p9,int p10,
      	      	       int p11,int p12,int p13,int p14,int p15){
    super(label,material);
    nodes=new int[15];
    nodes[0]=p1;
    nodes[1]=p2;
    nodes[2]=p3;
    nodes[3]=p4;
    nodes[4]=p5;
    nodes[5]=p6;
    nodes[6]=p7;
    nodes[7]=p8;
    nodes[8]=p9;
    nodes[9]=p10;
    nodes[10]=p11;
    nodes[11]=p12;
    nodes[12]=p13;
    nodes[13]=p14;
    nodes[14]=p15;
  }

/**
 * vf\z
 * @param label vfx
 * @param material ޗԍ
 * @param p ߓ_ԍi[z
 */
  public WedgeElement2(int label,int material,int p[]){
    this(label,material,p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8],
      	 p[9],p[10],p[11],p[12],p[13],p[14]);
  }

//--------------------------------------------------------------------//
/**
 * vf̂Ԃ
 * @return vf
 */
  public String getName(){
    return ELEMENT_NAME;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_Ԃ
 * @return ߓ_
 */
  public int nodeCount(){
    return NODE_COUNT;
  }

//--------------------------------------------------------------------//
/**
 * vfEԂ
 * @return vfE
 */
  public int borderCount(){
    return BORDER_COUNT;
  }

//--------------------------------------------------------------------//
/**
 * vfEԂ
 * @param element vfx
 * @param index vfẼCfbNX
 * @return vfEi[z
 */
  public ElementBorder border(int element,int index){
    switch(index){
      default:
      	return null;
      case 0:
      	return new TriangleBorder2(element,nodes[0],nodes[2],nodes[1],
      	      	      	      	   nodes[8],nodes[7],nodes[6]);
      case 1:
      	return new TriangleBorder2(element,nodes[3],nodes[4],nodes[5],
      	      	      	      	   nodes[9],nodes[10],nodes[11]);
      case 2:
      	return new QuadangleBorder2(element,nodes[0],nodes[1],nodes[4],
      	      	      	      	    nodes[3],nodes[6],nodes[13],
      	      	      	      	    nodes[9],nodes[12]);
      case 3:
      	return new QuadangleBorder2(element,nodes[1],nodes[2],nodes[5],
      	      	      	      	    nodes[4],nodes[7],nodes[14],
      	      	      	      	    nodes[10],nodes[13]);
      case 4:
      	return new QuadangleBorder2(element,nodes[2],nodes[0],nodes[3],
      	      	      	      	    nodes[5],nodes[8],nodes[12],
      	      	      	      	    nodes[11],nodes[14]);
    }
  }

//--------------------------------------------------------------------//
/**
 * vfߓ_̊pxԂ
 * @param p ߓ_i[z
 * @return vfߓ_̊pxi[z
 */
  public double[] angle(Point3D p[]){
    double angle[]=new double[NODE_COUNT];
    for(int i=0;i<6;i++){
      angle[i]=Vector3D.angle(new Vector3D(p[i],p[ANGLE[i][0]]),
      	      	      	      new Vector3D(p[i],p[ANGLE[i][1]]),
      	      	      	      new Vector3D(p[i],p[ANGLE[i][2]]));
    }
    for(int i=6;i<15;i++){
      angle[i]=Vector3D.angle(new Vector3D(p[i],p[ANGLE[i][0]]),
      	      	      	      new Vector3D(p[i],p[ANGLE[i][1]]));
    }
    return angle;
  }

//--------------------------------------------------------------------//
/**
 * `֐s<br>
 * { <i>N<sub>i</sub></i>
 *   <i>dN<sub>i</sub></i> /<i>d</i>
 *   <i>dN<sub>i</sub></i> /<i>d</i>
 *   <i>dN<sub>i</sub></i> /<i>d</i> }<br>
 * Ԃ
 * @param xsi <i></i> W
 * @param eta <i></i> W
 * @param zeta <i></i> W
 * @return `֐s
 */
  public Matrix shapeFunction(double xsi,double eta,double zeta){
    Matrix m=new DefaultMatrix(NODE_COUNT,4);
    double xe=1.0-xsi-eta;
    m.set(0,0,xe*(xe-0.5*zeta-1.0)*(1.0-zeta));
    m.set(1,0,xsi*(xsi-0.5*zeta-1.0)*(1.0-zeta));
    m.set(2,0,eta*(eta-0.5*zeta-1.0)*(1.0-zeta));
    m.set(3,0,xe*(xe+0.5*zeta-1.0)*(1.0+zeta));
    m.set(4,0,xsi*(xsi+0.5*zeta-1.0)*(1.0+zeta));
    m.set(5,0,eta*(eta+0.5*zeta-1.0)*(1.0+zeta));
    m.set(6,0,2.0*xe*xsi*(1.0-zeta));
    m.set(7,0,2.0*xsi*eta*(1.0-zeta));
    m.set(8,0,2.0*eta*xe*(1.0-zeta));
    m.set(12,0,2.0*xe*xsi*(1.0+zeta));
    m.set(13,0,2.0*xsi*eta*(1.0+zeta));
    m.set(14,0,2.0*eta*xe*(1.0+zeta));
    m.set(9,0,xe*(1.0+zeta)*(1.0-zeta));
    m.set(10,0,xsi*(1.0+zeta)*(1.0-zeta));
    m.set(11,0,eta*(1.0+zeta)*(1.0-zeta));
    m.set(0,1,-(2.0*xe-0.5*zeta-1.0)*(1.0-zeta));
    m.set(1,1,(2.0*xsi-0.5*zeta-1.0)*(1.0-zeta));
    m.set(3,1,-(2.0*xe+0.5*zeta-1.0)*(1.0+zeta));
    m.set(4,1,(2.0*xsi+0.5*zeta-1.0)*(1.0+zeta));
    m.set(6,1,2.0*(xe-xsi)*(1.0-zeta));
    m.set(7,1,2.0*eta*(1.0-zeta));
    m.set(8,1,-2.0*eta*(1.0-zeta));
    m.set(9,1,2.0*(xe-xsi)*(1.0+zeta));
    m.set(10,1,2.0*eta*(1.0+zeta));
    m.set(11,1,-2.0*eta*(1.0+zeta));
    m.set(12,1,-(1.0+zeta)*(1.0-zeta));
    m.set(13,1,(1.0+zeta)*(1.0-zeta));
    m.set(0,2,-(2.0*xe-0.5*zeta-1.0)*(1.0-zeta));
    m.set(2,2,(2.0*eta-0.5*zeta-1.0)*(1.0-zeta));
    m.set(3,2,-(2.0*xe+0.5*zeta-1.0)*(1.0+zeta));
    m.set(5,2,(2.0*eta+0.5*zeta-1.0)*(1.0+zeta));
    m.set(6,2,-2.0*xsi*(1.0-zeta));
    m.set(7,2,2.0*xsi*(1.0-zeta));
    m.set(8,2,2.0*(xe-eta)*(1.0-zeta));
    m.set(9,2,-2.0*xsi*(1.0+zeta));
    m.set(10,2,2.0*xsi*(1.0+zeta));
    m.set(11,2,2.0*(xe-eta)*(1.0+zeta));
    m.set(12,2,-(1.0+zeta)*(1.0-zeta));
    m.set(14,2,(1.0+zeta)*(1.0-zeta));
    m.set(0,3,xe*(zeta-xe+0.5));
    m.set(1,3,xsi*(zeta-xsi+0.5));
    m.set(2,3,eta*(zeta-eta+0.5));
    m.set(3,3,xe*(zeta+xe-0.5));
    m.set(4,3,xsi*(zeta+xsi-0.5));
    m.set(5,3,eta*(zeta+eta-0.5));
    m.set(6,3,-2.0*xe*xsi);
    m.set(7,3,-2.0*xsi*eta);
    m.set(8,3,-2.0*eta*xe);
    m.set(9,3,2.0*xe*xsi);
    m.set(10,3,2.0*xsi*eta);
    m.set(11,3,2.0*eta*xe);
    m.set(12,3,-2.0*xe*zeta);
    m.set(13,3,-2.0*xsi*zeta);
    m.set(14,3,-2.0*eta*zeta);
    return m;
  }

//--------------------------------------------------------------------//
/**
 * ʃ}gbNXԂ
 * @param p ߓ_i[z
 * @param density ޗ̖x
 * @return ʃ}gbNX
 */
  public Matrix massMatrix(Point3D p[],double density){
    Matrix m=new DefaultMatrix(3*NODE_COUNT);
    for(int i=0;i<9;i++){              // KEXϕ
      double dw=GW3[i/3];
      Matrix sf=shapeFunction(GTRI2[(i%3)%2],GTRI2[(i%3)/2],GX3[i/3]);
      Matrix jacob=jacobianMatrix(p,sf);
      double jacobian=dw*jacobian(jacob);
      Matrix ms=new DefaultMatrix(45);

      for(int i1=0;i1<NODE_COUNT;i1++){
      	for(int j1=0;j1<NODE_COUNT;j1++){
      	  double value=jacobian*sf.get(i1,0)*sf.get(j1,0);
      	  int i3=3*i1;
      	  int j3=3*j1;
      	  ms.set(i3,j3,value);
      	  ms.set(i3+1,j3+1,value);
      	  ms.set(i3+2,j3+2,value);
      	}
      }
      m.add(ms);
    }
    m.mul(density*V_COEF);
    return m;
  }

//--------------------------------------------------------------------//
/**
 * }gbNXԂ
 * @param p ߓ_i[z
 * @param d1  - c}gbNX
 * @return }gbNX
 */
  public Matrix stiffnessMatrix(Point3D p[],Matrix d1){
    Matrix k=new DefaultMatrix(3*NODE_COUNT);
    for(int i=0;i<9;i++){              // KEXϕ
      k.add(stiffnessMatrix(p,d1,GTRI2[(i%3)%2],GTRI2[(i%3)/2],GX3[i/3],
      	      	      	    GW3[i/3]));
    }
    k.mul(V_COEF);
    return k;
  }

//--------------------------------------------------------------------//
/**
 * vfcԂ
 * @param p ߓ_i[z
 * @param d ߓ_ψʂi[z
 * @return vfci[z
 */
  public Strain[] strain(Point3D p[],Vector3D d[]){
    return strain(p,d,XSI,ETA,ZETA);
  }

//--------------------------------------------------------------------//
/**
 * vf͂Ԃ
 * @param p ߓ_i[z
 * @param d ߓ_ψʂi[z
 * @param d1  - c}gbNX
 * @return vf͂i[z
 */
  public Stress[] stress(Point3D p[],Vector3D d[],Matrix d1){
    return stress(p,d,d1,XSI,ETA,ZETA);
  }

//--------------------------------------------------------------------//
/**
 * `֐}gbNX<br>
 * { <i>N<sub>i</sub>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return `֐}gbNX
 */
  public Matrix shapeFunctionMatrix(Point3D p[],double coef){
    Matrix s=new DefaultMatrix(NODE_COUNT);
    for(int i=0;i<9;i++){		// KEXϕ
      s.add(shapeFunctionMatrix(p,GTRI2[(i%3)%2],GTRI2[(i%3)/2],
      	      	      	      	GX3[i/3],GW3[i/3]));
    }
    s.mul(V_COEF*coef);
    return s;
  }

//--------------------------------------------------------------------//
/**
 * gU}gbNX<br>
 * { <i>N<sub>i</sub></i>E<i>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return gU}gbNX
 */
  public Matrix gradMatrix(Point3D p[],double coef){
    Matrix g=new DefaultMatrix(NODE_COUNT);
    for(int i=0;i<9;i++){		// KEXϕ
      g.add(gradMatrix(p,GTRI2[(i%3)%2],GTRI2[(i%3)/2],GX3[i/3],
      	      	       GW3[i/3]));
    }
    g.mul(V_COEF*coef);
    return g;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @return rΏۂ̃IuWFNg <code>WedgeElement2</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof WedgeElement2){
      return super.equals(obj);
    }
    else{
      return false;
    }
  }
}
