package fem.result;
import java.util.ArrayList;
import java.util.Collections;
import fem.bc.BoundaryCondition;
import fem.bc.Restraint;
import fem.bc.Temperature;
import figure.Tensor3D;
import figure.Vector;
import figure.Vector3DR;

//--------------------------------------------------------------------//
/**
 * vZʃNX
 */
public class Result{

/** f[^\ int ^ */
  public static final int NONE=-1;

/** ψʂ\ int ^ */
  public static final int DISPLACEMENT=0;

/** c\ int ^ */
  public static final int STRAIN=1;

/** ͂\ int ^ */
  public static final int STRESS=2;

/** x\ int ^ */
  public static final int TEMPERATURE=3;

/** <i>x</i> \ int ^ */
  public static final int X=0;

/** <i>y</i> \ int ^ */
  public static final int Y=1;

/** <i>z</i> \ int ^ */
  public static final int Z=2;

/** <i>x</i> ]\ int ^ */
  public static final int RX=3;

/** <i>y</i> ]\ int ^ */
  public static final int RY=4;

/** <i>z</i> ]\ int ^ */
  public static final int RZ=5;

/** <i>xy</i> f\ int ^ */
  public static final int XY=3;

/** <i>yz</i> f\ int ^ */
  public static final int YZ=4;

/** <i>zx</i> f\ int ^ */
  public static final int ZX=5;

/** 傫\ int ^ */
  public static final int MAGNITUDE=6;

/** ő听\ int ^ */
  public static final int MAX_PRINCIPAL=7;

/** ŏ听\ int ^ */
  public static final int MIN_PRINCIPAL=8;

/** Ԏ听\ int ^ */
  public static final int MID_PRINCIPAL=9;

/** ő傹f\ int ^ */
  public static final int MAX_SHARE=10;

/** ~[[X͂\ int ^ */
  public static final int VON_MISES=11;

/** Vtg */
  public static final int SHIFT=12;

/** ߓ_ψʂi[郊Xg */
  protected ArrayList<Vector3DR> displacement;

/** ߓ_ci[郊Xg */
  protected ArrayList<Strain> strain1;

/** ߓ_ci[郊Xg */
  protected ArrayList<Strain> strain2;

/** ߓ_͂i[郊Xg */
  protected ArrayList<Stress> stress1;

/** ߓ_͂i[郊Xg */
  protected ArrayList<Stress> stress2;

/** ߓ_xi[郊Xg */
  protected ArrayList<Double> temperature;

/** ߓ_ψʂ̑傫̍ől */
  protected double dispMax;

/** ͌ʂ̗L\ boolean ^ */
  protected boolean calculated;

/**
 * vZʃIuWFNg\z
 */
  public Result(){
    displacement=new ArrayList<Vector3DR>();
    strain1=new ArrayList<Strain>();
    strain2=new ArrayList<Strain>();
    stress1=new ArrayList<Stress>();
    stress2=new ArrayList<Stress>();
    temperature=new ArrayList<Double>();
    dispMax=0.0;
    calculated=false;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_Ԃ
 * @return ߓ_
 */
  public int size(){
    int size=displacement.size();
    if(size==0) size=temperature.size();
    return size;
  }

//--------------------------------------------------------------------//
/**
 * ͌ʂ̗L\ boolean ^Ԃ
 * @return ͌ʂ݂ꍇ true
 */
  public boolean calculated(){
    return calculated;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_ψʂݒ肷
 * @param bc E
 * @param disp ߓ_ψʂ\xNg
 * @param restraints ߓ_Si[Xg
 */
  public void setDisplacement(BoundaryCondition bc,Vector disp,
      	      	      	      ArrayList<Restraint> restraints){
    int size=bc.nodeCount;
    displacement.clear();
    int ii=0;
    for(int i=0;i<size;i++){
      Vector3DR v=new Vector3DR();
      int i0=bc.nodeIndex(i);
      int dof=bc.dof(i);
      for(int j=0;j<dof;j++){
      	int bcl=bc.bcList[i0+j];
      	double dd=0.0;
      	if(bcl<0){
      	  dd=disp.get(ii);
      	  ii++;
      	}
      	else{
      	  dd=restraints.get(bcl/6).get(j);
      	}
      	switch(j){
      	  case X:
      	    v.setX(dd);
      	    break;
      	  case Y:
      	    v.setY(dd);
      	    break;
      	  case Z:
      	    v.setZ(dd);
      	    break;
      	  case RX:
      	    v.setRX(dd);
      	    break;
      	  case RY:
      	    v.setRY(dd);
      	    break;
      	  case RZ:
      	    v.setRZ(dd);
      	    break;
      	}
      }
      dispMax=Math.max(dispMax,v.magnitude());
      displacement.add(v);
    }
    displacement.trimToSize();
    calculated=true;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_xꊇݒ肷
 * @param nodeCount ߓ_
 * @param t ߓ_x
 */
  public void fillTemperature(int nodeCount,double t){
    temperature.clear();
    for(int i=0;i<nodeCount;i++){
      temperature.add(t);
    }
    temperature.trimToSize();
  }

//--------------------------------------------------------------------//
/**
 * ߓ_xݒ肷
 * @param bc E
 * @param t ߓ_x\xNg
 * @param temp ߓ_Œ艷xi[Xg
 */
  public void setTemperature(BoundaryCondition bc,Vector t,
      	      	      	     ArrayList<Temperature> temp){
    int size=bc.nodeCount;
    temperature.clear();
    int ii=0;
    for(int i=0;i<size;i++){
      double tt=0.0;
      if(bc.bcList[i]<0){
      	tt=t.get(ii);
      	ii++;
      }
      else{
      	tt=temp.get(bc.bcList[i]).temperature();
      }
      dispMax=Math.max(dispMax,tt);
      temperature.add(tt);
    }
    temperature.trimToSize();
    calculated=true;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_cǉ
 * @param strain1 ߓ_c
 * @param strain2 ߓ_c
 */
  public void addStrain(Strain strain1,Strain strain2){
    this.strain1.add(strain1);
    this.strain2.add(strain2);
  }

//--------------------------------------------------------------------//
/**
 * ߓ_͂ǉ
 * @param stress1 ߓ_
 * @param stress2 ߓ_
 */
  public void addStress(Stress stress1,Stress stress2){
    this.stress1.add(stress1);
    this.stress2.add(stress2);
  }

//--------------------------------------------------------------------//
/**
 * ߓ_ψʂԂ
 * @param index ߓ_̃CfbNX
 * @return w肳ꂽʒu̐ߓ_ψ
 */
  public Vector3DR getDisplacement(int index){
    return displacement.get(index);
  }

//--------------------------------------------------------------------//
/**
 * ߓ_ψʂ̑傫̍őlԂ
 * @return ߓ_ψʂ̑傫̍ől
 */
  public double dispMax(){
    return dispMax;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_cԂ
 * @param index ߓ_̃CfbNX
 * @return w肳ꂽʒu̐ߓ_c
 */
  public Strain getStrain1(int index){
    return strain1.get(index);
  }

//--------------------------------------------------------------------//
/**
 * ߓ_cԂ
 * @param index ߓ_̃CfbNX
 * @return w肳ꂽʒu̐ߓ_c
 */
  public Strain getStrain2(int index){
    return strain2.get(index);
  }

//--------------------------------------------------------------------//
/**
 * ߓ_͂Ԃ
 * @param index ߓ_̃CfbNX
 * @return w肳ꂽʒu̐ߓ_
 */
  public Stress getStress1(int index){
    return stress1.get(index);
  }

//--------------------------------------------------------------------//
/**
 * ߓ_͂Ԃ
 * @param index ߓ_̃CfbNX
 * @return w肳ꂽʒu̐ߓ_
 */
  public Stress getStress2(int index){
    return stress2.get(index);
  }

//--------------------------------------------------------------------//
/**
 * ߓ_xԂ
 * @param index ߓ_̃CfbNX
 * @return w肳ꂽʒu̐ߓ_x
 */
  public double getTemperature(int index){
    return temperature.get(index);
  }

//--------------------------------------------------------------------//
/**
 * f[^o
 * @param param f[^̎ނ\ int ^
 * @param component f[^̐\ int ^
 * @param index ߓ_̃CfbNX
 * @return w肳ꂽf[^
 */
  public double getData(int param,int component,int index){
    switch(param){
      case DISPLACEMENT:
      	Vector3DR disp=getDisplacement(index);
      	switch(component){
      	  case X:
      	    return disp.x;
      	  case Y:
      	    return disp.y;
      	  case Z:
      	    return disp.z;
      	  case RX:
      	    return disp.rx;
      	  case RY:
      	    return disp.ry;
      	  case RZ:
      	    return disp.rz;
      	  case MAGNITUDE:
      	    return disp.magnitude();
      	}
      	break;
      case STRAIN:
      	if(component<SHIFT){
      	  return getData(getStrain1(index),component);
      	}
      	else{
      	  return getData(getStrain2(index),component-SHIFT);
      	}
      case STRESS:
      	if(component<SHIFT){
      	  return getData(getStress1(index),component);
      	}
      	else{
      	  return getData(getStress2(index),component-SHIFT);
      	}
      case TEMPERATURE:
      	return getTemperature(index);
    }
    return 0.0;
  }

//--------------------------------------------------------------------//
/**
 * cf[^o
 * @param strain c
 * @param component f[^̐\ int ^
 * @return w肳ꂽf[^
 */
  protected double getData(Strain strain,int component){
    if(component<6){
      return strain.vector().get(component);
    }
    else if(component<=10){
      Tensor3D pri=strain.principal();
      if(component==MAX_PRINCIPAL)      return pri.xx;
      else if(component==MIN_PRINCIPAL) return pri.zz;
      else if(component==MID_PRINCIPAL) return pri.yy;
      else if(component==MAX_SHARE)     return 0.5*(pri.xx-pri.zz);
    }
    return 0.0;
  }

//--------------------------------------------------------------------//
/**
 * ̓f[^o
 * @param stress 
 * @param component f[^̐\ int ^
 * @return w肳ꂽf[^
 */
  protected double getData(Stress stress,int component){
    if(component<6){
      return stress.vector().get(component);
    }
    else if(component<=10){
      Tensor3D pri=stress.principal();
      if(component==MAX_PRINCIPAL)      return pri.xx;
      else if(component==MIN_PRINCIPAL) return pri.zz;
      else if(component==MID_PRINCIPAL) return pri.yy;
      else if(component==MAX_SHARE)     return 0.5*(pri.xx-pri.zz);
    }
    else if(component==VON_MISES){
      return stress.mises();
    }
    return 0.0;
  }

//--------------------------------------------------------------------//
/**
 * vZʂ
 */
  public void clear(){
    displacement.clear();
    strain1.clear();
    strain2.clear();
    stress1.clear();
    stress2.clear();
    temperature.clear();
    dispMax=0.0;
    calculated=false;
  }
}
