package figure;

//--------------------------------------------------------------------//
/**
 * 3e\NX
 */
public class Tensor3D implements Cloneable{

/** <i>xx</i>  */
  public double xx;

/** <i>xy</i>  */
  public double xy;

/** <i>xz</i>  */
  public double xz;

/** <i>yx</i>  */
  public double yx;

/** <i>yy</i>  */
  public double yy;

/** <i>yz</i>  */
  public double yz;

/** <i>zx</i>  */
  public double zx;

/** <i>zy</i>  */
  public double zy;

/** <i>zz</i>  */
  public double zz;

/**
 * e\ftHg 0 ō\z
 */
  public Tensor3D(){
    this(0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
  }

/**
 * xNge\\z
 * @param vector xNg
 */
  public Tensor3D(Vector vector){
    this(vector.get(0),vector.get(1),vector.get(2),
      	 vector.get(3),vector.get(4),vector.get(5));
  }

/**
 * s񂩂e\\z
 * @param matrix s
 */
  public Tensor3D(Matrix matrix){
    this(matrix.get(0,0),matrix.get(0,1),matrix.get(0,2),
      	 matrix.get(1,0),matrix.get(1,1),matrix.get(1,2),
      	 matrix.get(2,0),matrix.get(2,1),matrix.get(2,2));
  }

/**
 * 3Ώ̃e\\z
 * @param xx <i>xx</i> 
 * @param yy <i>yy</i> 
 * @param zz <i>zz</i> 
 * @param xy <i>xy</i> 
 * @param yz <i>yz</i> 
 * @param xz <i>xz</i> 
 */
  public Tensor3D(double xx,double yy,double zz,
      	      	  double xy,double yz,double xz){
    this(xx,xy,xz,xy,yy,yz,xz,yz,zz);
  }

/**
 * 3e\\z
 * @param xx <i>xx</i> 
 * @param xy <i>xy</i> 
 * @param xz <i>xz</i> 
 * @param yx <i>yx</i> 
 * @param yy <i>yy</i> 
 * @param yz <i>yz</i> 
 * @param zx <i>zx</i> 
 * @param zy <i>zy</i> 
 * @param zz <i>zz</i> 
 */
  public Tensor3D(double xx,double xy,double xz,
      	      	  double yx,double yy,double yz,
      	      	  double zx,double zy,double zz){
    this.xx=xx;
    this.xy=xy;
    this.xz=xz;
    this.yx=yx;
    this.yy=yy;
    this.yz=yz;
    this.zx=zx;
    this.zy=zy;
    this.zz=zz;
  }

//--------------------------------------------------------------------//
/**
 * ŗLlԂ
 * @return ŗLli[ <code>Tensor3D</code>
 */
  public Tensor3D principal(){
    DefaultMatrix m=(DefaultMatrix)matrix();
    Matrix ev=m.eigenvalue(100);
    if(ev==null) return new Tensor3D();
    double s[]=new double[3];
    for(int i=0;i<3;i++) s[i]=ev.get(i,i);
    for(int i=0;i<2;i++){
      for(int j=i+1;j<3;j++){
      	if(s[i]<s[j]){
      	  double temp=s[i];
      	  s[i]=s[j];
      	  s[j]=temp;
      	}
      }
    }
    return new Tensor3D(s[0],s[1],s[2],0.0,0.0,0.0);
  }

//--------------------------------------------------------------------//
/**
 * e\xNgƂĕԂ
 * @return ̃e\\ <code>Vector</code>
 */
  public Vector vector(){
    Vector vector=new Vector(6);
    vector.set(0,xx);
    vector.set(1,yy);
    vector.set(2,zz);
    vector.set(3,xy);
    vector.set(4,yz);
    vector.set(5,xz);
    return vector;
  }

//--------------------------------------------------------------------//
/**
 * e\sƂĕԂ
 * @return ̃e\\ <code>Matrix</code>
 */
  public Matrix matrix(){
    Matrix matrix=new DefaultMatrix(3);
    matrix.set(0,0,xx);
    matrix.set(0,1,xy);
    matrix.set(0,2,xz);
    matrix.set(1,0,yx);
    matrix.set(1,1,yy);
    matrix.set(1,2,yz);
    matrix.set(2,0,zx);
    matrix.set(2,1,zy);
    matrix.set(2,2,zz);
    return matrix;
  }

//--------------------------------------------------------------------//
/**
 * e\a
 * @param t e\
 */
  public void add(Tensor3D t){
    xx+=t.xx;
    xy+=t.xy;
    xz+=t.xz;
    yx+=t.yx;
    yy+=t.yy;
    yz+=t.yz;
    zx+=t.zx;
    zy+=t.zy;
    zz+=t.zz;
  }

//--------------------------------------------------------------------//
/**
 * XJ[{
 * @param a |XJ[
 */
  public void mul(double a){
    xx*=a;
    xy*=a;
    xz*=a;
    yx*=a;
    yy*=a;
    yz*=a;
    zx*=a;
    zy*=a;
    zz*=a;
  }

//--------------------------------------------------------------------//
/**
 * e\ e\|
 * @param t ςvZe\
 */
  public void leftMul(Tensor3D t){
    double a11=t.xx*xx+t.xy*yx+t.xz*zx;
    double a12=t.xx*xy+t.xy*yy+t.xz*zy;
    double a13=t.xx*xz+t.xy*yz+t.xz*zz;
    double a21=t.yx*xx+t.yy*yx+t.yz*zx;
    double a22=t.yx*xy+t.yy*yy+t.yz*zy;
    double a23=t.yx*xz+t.yy*yz+t.yz*zz;
    double a31=t.zx*xx+t.zy*yx+t.zz*zx;
    double a32=t.zx*xy+t.zy*yy+t.zz*zy;
    double a33=t.zx*xz+t.zy*yz+t.zz*zz;
    xx=a11;
    xy=a12;
    xz=a13;
    yx=a21;
    yy=a22;
    yz=a23;
    zx=a31;
    zy=a32;
    zz=a33;
  }

//--------------------------------------------------------------------//
/**
 * e\ e\E|
 * @param t ςvZe\
 */
  public void rightMul(Tensor3D t){
    double a11=xx*t.xx+xy*t.yx+xz*t.zx;
    double a12=xx*t.xy+xy*t.yy+xz*t.zy;
    double a13=xx*t.xz+xy*t.yz+xz*t.zz;
    double a21=yx*t.xx+yy*t.yx+yz*t.zx;
    double a22=yx*t.xy+yy*t.yy+yz*t.zy;
    double a23=yx*t.xz+yy*t.yz+yz*t.zz;
    double a31=zx*t.xx+zy*t.yx+zz*t.zx;
    double a32=zx*t.xy+zy*t.yy+zz*t.zy;
    double a33=zx*t.xz+zy*t.yz+zz*t.zz;
    xx=a11;
    xy=a12;
    xz=a13;
    yx=a21;
    yy=a22;
    yz=a23;
    zx=a31;
    zy=a32;
    zz=a33;
  }

//--------------------------------------------------------------------//
/**
 * ̐Βl̍őlԂ
 * @return ̐Βl̍ől
 */
  public double getMax(){
    double max=Math.max(Math.abs(xx),Math.abs(xy));
    max=Math.max(max,Math.abs(xz));
    max=Math.max(max,Math.abs(yx));
    max=Math.max(max,Math.abs(yy));
    max=Math.max(max,Math.abs(yz));
    max=Math.max(max,Math.abs(zx));
    max=Math.max(max,Math.abs(zy));
    return Math.max(max,Math.abs(zz));
  }

//--------------------------------------------------------------------//
/**
 * e\]u
 */
  public void trans(){
    double temp=xy;
    xy=yx;
    yx=temp;
    temp=yz;
    yz=zy;
    zy=temp;
    temp=zx;
    zx=xz;
    xz=temp;
  }

//--------------------------------------------------------------------//
/**
 * e\]
 * @param t ]e\
 */
  public void rotate(Tensor3D t){
    Tensor3D tt=(Tensor3D)t.clone();
    tt.trans();
    leftMul(tt);
    rightMul(t);
  }

//--------------------------------------------------------------------//
/**
 * ̃e\Ώ̂ǂԂ
 * @return ̃e\Ώ̂ȏꍇ true
 */
  public boolean isSymmetry(){
    return ((xy==yx) && (xz==zx) && (yz==zy));
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      return super.clone();
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    long l11=Double.doubleToLongBits(xx);
    long l12=Double.doubleToLongBits(xy);
    long l13=Double.doubleToLongBits(xz);
    long l21=Double.doubleToLongBits(yx);
    long l22=Double.doubleToLongBits(yy);
    long l23=Double.doubleToLongBits(yz);
    long l31=Double.doubleToLongBits(zx);
    long l32=Double.doubleToLongBits(zy);
    long l33=Double.doubleToLongBits(zz);
    int bit=(int)(l11^(l11>>>32));
    bit=31*bit+(int)(l12^(l12>>>32));
    bit=31*bit+(int)(l13^(l13>>>32));
    bit=31*bit+(int)(l21^(l21>>>32));
    bit=31*bit+(int)(l22^(l22>>>32));
    bit=31*bit+(int)(l23^(l23>>>32));
    bit=31*bit+(int)(l31^(l31>>>32));
    bit=31*bit+(int)(l32^(l32>>>32));
    bit=31*bit+(int)(l33^(l33>>>32));
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>Tensor3D</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof Tensor3D){
      Tensor3D t=(Tensor3D)obj;
      return ((xx==t.xx) && (xy==t.xy) && (xz==t.xz)
      	   && (yx==t.yx) && (yy==t.yy) && (yz==t.yz)
      	   && (zx==t.zx) && (zy==t.zy) && (zz==t.zz));
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "Tensor3D\n"
      	  +xx+"\t"+xy+"\t"+xz+"\n"
      	  +yx+"\t"+yy+"\t"+yz+"\n"
      	  +zx+"\t"+zy+"\t"+zz+"\n";
  }
}
